theory DistrNormalisation
imports  "../PacketFilter/PacketFilter"
begin

text {* Theory for the distribution of the normalization.  Currently,
only supports one of the parallel combinators. However, all the lemmas
can straightforwardly be transfered to the other ones. TODO!

*}



lemma distr2I: "(F = F1 \<Oplus> F2) \<Longrightarrow>  (((N  \<Otimes>\<^sub>2\<^sub>I F) o f) = 
               (((N \<Otimes>\<^sub>2\<^sub>I F1) o f)  \<Oplus> ((N \<Otimes>\<^sub>2\<^sub>I F2)  o f))) "
apply (rule ext)
apply (simp add: prod_2_id_def prod_2_def map_add_def 
            split: decision.splits option.splits)
done



lemma domStart: "t \<in> dom p1 \<Longrightarrow> (p1 \<Oplus> p2) t = p1 t"
apply (simp add: dom_def map_add_def)
apply (simp split: option.splits)
apply (rule impI)
apply auto
done

lemma dom2IL: "\<lbrakk>dom A = UNIV;t \<in> dom a\<rbrakk> \<Longrightarrow> t \<in> (dom ((A \<Otimes>\<^sub>2 a) o (\<lambda> x. (x,x))))"
apply (simp add: prod_2_def)
apply (simp add: dom_def split: option.splits decision.splits prod.splits)
apply auto
done


lemma dom2IL_not: "\<lbrakk>dom NAT = UNIV;t \<notin> dom a\<rbrakk> \<Longrightarrow> t \<notin>  (dom ((A \<Otimes>\<^sub>2 a) o (\<lambda> x. (x,x))))"
apply (simp add: prod_2_def)
apply (simp add: dom_def split: option.splits decision.splits)
done

lemma UNIV_dom: "\<lbrakk>{x. x = y} = UNIV; t \<noteq> y\<rbrakk> \<Longrightarrow> False"
apply auto
done


lemma UNIV_dom2: "\<lbrakk>{x. P x} = UNIV; \<not> P t\<rbrakk> \<Longrightarrow> False"
apply auto
done


lemma dom2IL_not2: "\<lbrakk>dom A = UNIV;t \<notin>  (dom ((A \<Otimes>\<^sub>2 a) o (\<lambda> x. (x,x))))\<rbrakk> \<Longrightarrow> t \<notin> (dom a)"
apply (simp add: prod_2_def)
apply (simp add: dom_def split: option.splits decision.splits) 
apply (rule FalseE)
apply (erule UNIV_dom2)
apply auto
done



lemma NAT_aux:"\<lbrakk>dom A = UNIV; t \<in> dom a\<rbrakk> \<Longrightarrow> 
((A \<Otimes>\<^sub>2 (a \<Oplus> (list2policyP list))) o (\<lambda>x. (x,x))) t =
      (( ( ((A \<Otimes>\<^sub>2 a) o (\<lambda> x. (x,x))))) t) "
apply (simp add: prod_2_def)
apply (simp add: dom_def split: option.splits decision.splits)
apply auto
done



lemma NAT_aux1:"\<lbrakk>dom NAT = UNIV; t \<in> dom a\<rbrakk> \<Longrightarrow> 
((f o_f ((NAT \<Otimes>\<^sub>2 (a \<Oplus> (list2policyP list))) o (\<lambda>x. (x,x))))) t =
      (((f o_f (NAT \<Otimes>\<^sub>2 a) o (\<lambda>x. (x,x)))) t) "
apply (simp add: prod_2_def)
apply (simp add: policy_range_comp_def dom_def split: option.splits decision.splits)
apply auto
done



lemma NAT_aux2:"\<lbrakk>dom NAT = UNIV; t \<notin> dom a\<rbrakk> \<Longrightarrow> 
((f o_f (NAT \<Otimes>\<^sub>2 (a \<Oplus> (list2policyP list)))o (\<lambda>x. (x,x)))) t =
      (((f o_f (NAT \<Otimes>\<^sub>2 (list2policyP list)) o (\<lambda>x. (x,x))) t)) "
apply (simp add: prod_2_def)
apply (simp add: policy_range_comp_def dom_def split: option.splits decision.splits)
apply auto
done


lemma NAT_aux2a: "\<lbrakk>t \<notin> dom ((\<lambda>(x, y). x) o_f (NAT \<Otimes>\<^sub>2 a \<circ> (\<lambda>x. (x, x))));
        (((\<lambda>(x, y). x) o_f (NAT \<Otimes>\<^sub>2 a \<circ> (\<lambda>x. (x, x)))) \<Oplus>
         list2policyP (prod_list NAT list op \<Otimes>\<^sub>2 (\<lambda>x. (x, x)) (\<lambda>(x, y). x)))
         t =
        list2policyP (prod_list NAT list op \<Otimes>\<^sub>2 (\<lambda>x. (x, x)) (\<lambda>(x, y). x)) t\<rbrakk>
       \<Longrightarrow> ((\<lambda>(x, y). x) o_f (\<lambda>b. (NAT \<Otimes>\<^sub>2 a \<Oplus> list2policyP list) (b, b))) t =
          list2policyP (prod_list NAT list op \<Otimes>\<^sub>2 (\<lambda>x. (x, x)) (\<lambda>(x, y). x)) t"
apply (simp add: prod_2_def)
apply (simp add: policy_range_comp_def dom_def split: option.splits decision.splits)
apply auto
oops







lemma NAT_Distr2[rule_format]: 
 "dom NAT = UNIV \<Longrightarrow>
  (\<lambda> (x,y). x) o_f (NAT \<Otimes>\<^sub>2\<^sub>I  list2policyP F) = 
  list2policyP (NAT \<Otimes>\<^sub>2\<^sub>I\<^sub>L F)" 
apply (rule ext)
apply (erule NAT_Distr)
done





end





