
theory NormalisationIntegerPortProof
imports FWCompilationProof
begin



lemma ConcAssoc: "C((A \<oplus> B) \<oplus> D) = C(A \<oplus> (B \<oplus> D))"
apply (simp add: C.simps)
done


lemma aux26[simp]: "twoNetsDistinct a b c d \<Longrightarrow> 
             dom (C (AllowPortFromTo a b p)) \<inter> dom (C (DenyAllFromTo c d)) = {}"
by (auto simp: PLemmas twoNetsDistinct_def netsDistinct_def) auto


lemma wp2_aux[rule_format]: "wellformed_policy2 (xs @ [x]) \<longrightarrow> 
                             wellformed_policy2 xs"
apply (induct xs, simp_all)
apply (case_tac "a", simp_all)
done

lemma Cdom2: "x \<in> dom(C b) \<Longrightarrow> C (a \<oplus> b) x = (C b) x"
by (auto simp: C.simps)

lemma wp2Conc[rule_format]: "wellformed_policy2 (x#xs) \<Longrightarrow> wellformed_policy2 xs"
by (case_tac "x",simp_all)

lemma DAimpliesMR_E[rule_format]: "DenyAll \<in> set p \<longrightarrow>
                                   (\<exists> r. matching_rule x p = Some r)"
apply (simp add: matching_rule_def)
apply (rule_tac xs = p in rev_induct)
apply simp_all
by (metis C.simps(1) denyAllDom)




lemma DAimplieMR[rule_format]: "DenyAll \<in> set p \<Longrightarrow> matching_rule x p \<noteq> None"
by (auto intro: DAimpliesMR_E)

lemma MRList1[rule_format]: "x \<in> dom (C a) \<Longrightarrow> matching_rule x (b@[a]) = Some a"
by (simp add: matching_rule_def)

lemma MRList2: "x \<in> dom (C a) \<Longrightarrow> matching_rule x (c@b@[a]) = Some a"
by (simp add: matching_rule_def)

lemma MRList3: "x \<notin> dom (C xa) \<Longrightarrow>
            matching_rule x (a @ b # xs @ [xa]) = matching_rule x (a @ b # xs)"
by (simp add: matching_rule_def)

lemma CConcEnd[rule_format]: "C a x = Some y \<longrightarrow>
                              C (list2policy (xs @ [a])) x = Some y"
 (is "?P xs")
apply (rule_tac P = ?P in list2policy.induct)
by (simp_all add:C.simps)

lemma CConcStartaux: " \<lbrakk>C a x = None\<rbrakk> \<Longrightarrow> (C aa ++ C a) x = C aa x"
by (simp add: PLemmas)

lemma CConcStart[rule_format]: "xs \<noteq> [] \<longrightarrow> C a x = None \<longrightarrow>
                             C (list2policy (xs @ [a])) x = C (list2policy xs) x"
apply (rule list2policy.induct)
by (simp_all add: PLemmas)

lemma mrNnt[simp]: "matching_rule x p = Some a \<Longrightarrow> p \<noteq> []"
apply (simp add: matching_rule_def)
by auto

lemma mr_is_C[rule_format]: "matching_rule x p = Some a \<longrightarrow>
                             C (list2policy (p)) x = C a x"
apply (simp add: matching_rule_def)
apply (rule rev_induct)
apply simp_all
apply safe
apply (metis CConcEnd rotate_simps)
apply (metis CConcEnd)
apply (metis CConcStart domD domIff foldl_Nil matching_rule_rev.simps(2)
             option.simps(2) rev_foldl_cons rotate_simps)
done

lemma CConcStart2: "\<lbrakk>p \<noteq> []; x \<notin> dom (C a)\<rbrakk> \<Longrightarrow>
                    C (list2policy (p@[a])) x = C (list2policy p)x"
by (erule CConcStart,simp add: PLemmas)

lemma CConcEnd1: "\<lbrakk>q@p \<noteq> []; x \<notin> dom (C a)\<rbrakk> \<Longrightarrow>
                  C (list2policy (q@p@[a])) x = C (list2policy (q@p))x"
apply (subst lCdom2)
by (rule CConcStart2, simp_all)

lemma CConcEnd2[rule_format]: "x \<in> dom (C a) \<longrightarrow>
                               C (list2policy (xs @ [a])) x = C a x"
 (is "?P xs")
apply (rule_tac P = ?P in list2policy.induct)
by (auto simp:C.simps)


lemma bar3: "x \<in> dom (C (list2policy (xs @ [xa]))) \<Longrightarrow>
             x \<in> dom (C (list2policy xs)) \<or> x \<in> dom (C xa)"
by (metis CConcEnd1 domIff list2policy.simps(1) rotate_simps self_append_conv2)

lemma CeqEnd[rule_format,simp]: "a \<noteq> [] \<longrightarrow> x \<in> dom (C (list2policy a)) \<longrightarrow> 
                                C (list2policy (b@a)) x = (C (list2policy a)) x"
apply (rule rev_induct,simp_all) 
apply (case_tac "xs \<noteq> []", simp_all)
apply (case_tac "x \<in> dom (C xa)")
apply (metis CConcEnd2 MRList2 mr_is_C rotate_simps)
apply (metis CConcEnd1 CConcStart2 Nil_is_append_conv bar3 rotate_simps)
apply (metis MRList2 eq_Nil_appendI mr_is_C rotate_simps)
done

lemma CConcStartA[rule_format,simp]: " x \<in> dom (C a) \<longrightarrow>
                                      x \<in> dom (C (list2policy (a # b)))"
(is "?P b")
apply (rule_tac P = ?P in list2policy.induct)  
apply (simp_all add: C.simps)
done


lemma domConc: "\<lbrakk>x \<in> dom (C (list2policy b)); b \<noteq> []\<rbrakk>  \<Longrightarrow>
                x \<in> dom (C (list2policy (a@b)))"
by (auto simp: PLemmas)

lemma CeqStart[rule_format,simp]:
                          "x \<notin> dom (C (list2policy a)) \<longrightarrow> a \<noteq> [] \<longrightarrow> b \<noteq> [] \<longrightarrow>
                           C (list2policy (b@a)) x = (C (list2policy b)) x"
apply (rule list2policy.induct,simp_all)
apply (auto simp: list2policyconc PLemmas)
done 

lemma C_eq_if_mr_eq2: "\<lbrakk>matching_rule x a = Some r; matching_rule x b = Some r;
                       a \<noteq> []; b \<noteq> []\<rbrakk>  \<Longrightarrow>
                       (C (list2policy a)) x = (C (list2policy b)) x"
by (metis mr_is_C)

lemma nMRtoNone[rule_format]: "p \<noteq> [] \<longrightarrow> matching_rule x p = None \<longrightarrow>
                               C (list2policy p) x = None"
apply (rule rev_induct, simp_all)
apply (case_tac "xs = []", simp_all)
by (simp_all add: matching_rule_def dom_def)

lemma C_eq_if_mr_eq: 
 "\<lbrakk>matching_rule x b = matching_rule x a; a \<noteq> []; b \<noteq> []\<rbrakk> \<Longrightarrow>  
  (C (list2policy a)) x = (C (list2policy b)) x"
apply (cases "matching_rule x a = None") 
apply simp_all
apply (subst nMRtoNone)
apply (simp_all)
apply (subst nMRtoNone)
apply simp_all
by (auto intro: C_eq_if_mr_eq2)



lemma notmatching_notdom: "matching_rule x (p@[a]) \<noteq> Some a \<Longrightarrow> x \<notin> dom (C a)"
by (simp add: matching_rule_def split: if_splits)

lemma foo3a[rule_format]: "matching_rule x (a@[b]@c) = Some b \<longrightarrow>  r \<in> set c \<longrightarrow> 
                           b \<notin> set c \<longrightarrow> x \<notin> dom (C r)"
apply (rule rev_induct) 
apply simp_all
apply (rule impI|rule conjI|simp)+
apply (rule_tac p = "a @ b # xs" in notmatching_notdom,simp_all)
apply (rule impI,simp)+
apply (drule sym,drule mp, simp_all)
apply (rule MRList3[symmetric],drule sym)
apply (rule_tac p = "a @ b # xs" in notmatching_notdom,simp_all)
done

lemma foo3D: "\<lbrakk>wellformed_policy1 p; p = (DenyAll#ps); 
              matching_rule x p = Some DenyAll; r \<in> set ps\<rbrakk> \<Longrightarrow> x \<notin> dom (C r)"
by (rule_tac a = "[]" and b = "DenyAll" and c = "ps"  in foo3a, simp_all)

lemma foo4[rule_format]: "set p = set s \<and> (\<forall> r. r \<in> set p \<longrightarrow> x \<notin> dom (C r)) \<longrightarrow> 
                          (\<forall> r .r \<in> set s \<longrightarrow> x \<notin> dom (C r))"
by simp

lemma foo5b[rule_format]: "x \<in> dom (C b) \<longrightarrow> (\<forall> r. r \<in> set c \<longrightarrow> x \<notin> dom (C r))\<longrightarrow> 
                           matching_rule x (b#c) = Some b"
apply (simp add: matching_rule_def)
apply (rule_tac xs = c in rev_induct, simp_all)  
done

lemma mr_first: "\<lbrakk>x \<in> dom (C b); (\<forall> r. r \<in> set c \<longrightarrow> x \<notin> dom (C r)); s = b#c\<rbrakk> \<Longrightarrow> 
                           matching_rule x s = Some b"
by (simp add: foo5b)

lemma mr_charn[rule_format]: "a \<in> set p \<longrightarrow> (x \<in> dom (C a)) \<longrightarrow> 
                             (\<forall> r. r \<in> set p \<and> x \<in> dom (C r) \<longrightarrow> r = a) \<longrightarrow>  
                              matching_rule x p = Some a"
apply (rule_tac xs = p in rev_induct) 
by (simp_all add: matching_rule_def)

lemma foo8: "\<lbrakk>(\<forall> r. r \<in> set p \<and> x \<in> dom (C r) \<longrightarrow> r = a); set p = set s\<rbrakk> \<Longrightarrow> 
             (\<forall> r. r \<in> set s \<and> x \<in> dom (C r) \<longrightarrow> r = a)"
by auto

lemma mrConcEnd[rule_format]: "matching_rule x (b # p) = Some a \<longrightarrow> a \<noteq> b \<longrightarrow> 
                               matching_rule x p = Some a"
apply (simp add: matching_rule_def)
apply (rule_tac xs = p in rev_induct,simp_all) 
by auto


lemma wp3tl[rule_format]: "wellformed_policy3 p \<longrightarrow> wellformed_policy3 (tl p)"
by (induct p, simp_all, case_tac a, simp_all)

lemma wp3Conc[rule_format]: "wellformed_policy3 (a#p) \<longrightarrow> wellformed_policy3 p"
by (induct p, simp_all, case_tac a, simp_all)


lemma foo98[rule_format]:"matching_rule x (aa # p) = Some a \<longrightarrow> x \<in> dom (C r) \<longrightarrow> 
            r \<in> set p
           \<longrightarrow> a \<in> set p"
apply (simp add: matching_rule_def)
apply (rule rev_induct)
apply simp_all
apply (case_tac "r = xa", simp_all)
done


lemma mrMTNone[simp]: "matching_rule x [] = None"
by (simp add: matching_rule_def)

lemma DAAux[simp]: "x \<in> dom (C DenyAll)"
by (simp add: dom_def PolicyCombinators.PolicyCombinators C.simps)

lemma mrSet[rule_format]: "matching_rule x p = Some r \<longrightarrow> r \<in> set p"
apply (simp add: matching_rule_def)
apply (rule_tac xs=p in rev_induct)
apply simp_all
done

lemma mr_not_Conc: "singleCombinators p \<Longrightarrow> matching_rule x p \<noteq> Some (a\<oplus>b)"
apply (auto simp:  mrSet)
apply (drule mrSet)
apply (erule SCnotConc,simp)
done


lemma foo25[rule_format]: "wellformed_policy3 (p@[x]) \<longrightarrow> wellformed_policy3 p"
by (induct p, simp_all, case_tac a, simp_all)

lemma mr_in_dom[rule_format]: "matching_rule x p = Some a \<longrightarrow> x \<in> dom (C a)"
apply (rule_tac xs = p in rev_induct)
by (auto simp: matching_rule_def)


lemma wp3EndMT[rule_format]: "wellformed_policy3 (p@[xs]) \<longrightarrow> 
                             AllowPortFromTo a b po \<in> set p \<longrightarrow>
                             dom (C (AllowPortFromTo a b po)) \<inter> dom (C xs) = {}"
apply (induct p,simp_all)
apply (rule impI)+
apply (drule mp)
apply (erule wp3Conc)
by clarify auto

lemma foo29: "\<lbrakk>dom (C a) \<noteq> {}; dom (C a) \<inter> dom (C b) = {}\<rbrakk> \<Longrightarrow> a \<noteq> b"
by auto

lemma foo28:  "\<lbrakk>AllowPortFromTo a b po \<in> set p; 
               dom (C (AllowPortFromTo a b po)) \<noteq> {}; (wellformed_policy3 (p@[x]))\<rbrakk> 
               \<Longrightarrow> x \<noteq> AllowPortFromTo a b po"
by (metis foo29 C.simps wp3EndMT)

lemma foo28a[rule_format]: "x \<in> dom (C a) \<Longrightarrow> dom (C a) \<noteq> {}"
by auto

lemma allow_deny_dom[simp]: "dom (C (AllowPortFromTo a b po)) \<subseteq> 
                            dom (C (DenyAllFromTo a b))"
by (simp_all add: twoNetsDistinct_def netsDistinct_def PLemmas) auto 

lemma DenyAllowDisj: "dom (C (AllowPortFromTo a b p)) \<noteq> {} \<Longrightarrow> 
             dom (C (DenyAllFromTo a b)) \<inter> dom (C (AllowPortFromTo a b p))  \<noteq> {}"
by (metis Int_absorb1 allow_deny_dom)

lemma foo31: "\<lbrakk>(\<forall> r. r \<in> set p \<and> x \<in> dom (C r) \<longrightarrow> 
           (r = AllowPortFromTo a b po \<or> r = DenyAllFromTo a b \<or> r = DenyAll)); 
            set p = set s\<rbrakk> \<Longrightarrow> 
            (\<forall> r. r \<in> set s \<and> x \<in> dom (C r) \<longrightarrow> 
           (r = AllowPortFromTo a b po \<or> r = DenyAllFromTo a b \<or> r = DenyAll))"
by auto



lemma wp1_auxa: "wellformed_policy1_strong p\<Longrightarrow>(\<exists> r. matching_rule x p = Some r)"
apply (rule DAimpliesMR_E)
by (erule wp1_aux1aa)



lemma deny_dom[simp]:  "twoNetsDistinct a b c d \<Longrightarrow> dom (C (DenyAllFromTo a b)) \<inter>
                       dom (C (DenyAllFromTo c d)) = {}"
apply (simp add: C.simps)
by (erule aux6)

lemma domTrans: "\<lbrakk>dom a \<subseteq> dom b; dom(b) \<inter> dom (c) = {}\<rbrakk> \<Longrightarrow> dom(a) \<inter> dom(c) = {}" 
by auto

lemma DomInterAllowsMT: "\<lbrakk> twoNetsDistinct a b c d\<rbrakk>  \<Longrightarrow>
        dom (C (AllowPortFromTo a b p)) \<inter> dom (C (AllowPortFromTo c d po)) = {}"
apply (case_tac "p = po", simp_all)
apply (rule_tac b = "C (DenyAllFromTo a b)" in domTrans, simp_all)
apply (metis domComm aux26 tNDComm)
by (simp add: twoNetsDistinct_def netsDistinct_def PLemmas) auto

lemma DomInterAllowsMT_Ports: "\<lbrakk>p \<noteq> po\<rbrakk> \<Longrightarrow>
        dom (C (AllowPortFromTo a b p)) \<inter> dom (C (AllowPortFromTo c d po)) = {}"
by (simp add: twoNetsDistinct_def netsDistinct_def PLemmas) auto



lemma wellformed_policy3_charn[rule_format]: 
  "singleCombinators p \<longrightarrow> distinct p \<longrightarrow> allNetsDistinct p \<longrightarrow> 
   wellformed_policy1 p \<longrightarrow> wellformed_policy2 p  \<longrightarrow> wellformed_policy3 p"
apply (induct_tac p)   
apply simp_all
apply clarify
apply simp_all
apply (auto intro: singleCombinatorsConc ANDConc waux2 wp2Conc)
apply (case_tac a) 
apply simp_all
apply clarify
apply (case_tac r)
apply simp_all
apply (metis Int_commute) 
apply (metis DomInterAllowsMT aux7aa DomInterAllowsMT_Ports)
apply (metis aux0_0 mem_def)
done



lemma DistinctNetsDenyAllow: 
 "\<lbrakk>DenyAllFromTo b c \<in> set p; AllowPortFromTo a d po \<in> set p; allNetsDistinct p;
  dom (C (DenyAllFromTo b c)) \<inter> dom (C (AllowPortFromTo a d po)) \<noteq> {}\<rbrakk>
       \<Longrightarrow> b = a \<and> c = d" 
apply (simp add: allNetsDistinct_def)
apply (frule_tac x = "b" in spec) 
apply (drule_tac x = "d" in spec)
apply (drule_tac x = "a" in spec)
apply (drule_tac x = "c" in spec)
apply (metis Int_commute ND0aux1 ND0aux3 NDComm aux26 twoNetsDistinct_def 
             ND0aux2 ND0aux4)
done

lemma DistinctNetsAllowAllow: 
 "\<lbrakk>AllowPortFromTo b c poo \<in> set p; AllowPortFromTo a d po \<in> set p; 
  allNetsDistinct p; dom (C (AllowPortFromTo b c poo)) \<inter> 
  dom (C (AllowPortFromTo a d po)) \<noteq> {}\<rbrakk>
       \<Longrightarrow> b = a \<and> c = d \<and> poo = po" 
apply (simp add: allNetsDistinct_def)
apply (frule_tac x = "b" in spec) 
apply (drule_tac x = "d" in spec)
apply (drule_tac x = "a" in spec)
apply (drule_tac x = "c" in spec)
apply (metis DomInterAllowsMT DomInterAllowsMT_Ports ND0aux3 ND0aux4 NDComm 
             twoNetsDistinct_def)
done



lemma WP2RS2[simp]: 
  "\<lbrakk>singleCombinators p;
 distinct p;
 allNetsDistinct p\<rbrakk> \<Longrightarrow> 
   wellformed_policy2 (removeShadowRules2 p)"
 proof (induct p)
   case Nil thus ?case by simp
 next   
   case (Cons x xs) 
      have wp_xs: "wellformed_policy2 (removeShadowRules2 xs)" using prems
by (metis ANDConc distinct.simps(2) singleCombinatorsConc)
      show ?case
      proof (cases x) 
         case DenyAll thus ?thesis using wp_xs by simp
      next  
         case (DenyAllFromTo a b) thus ?thesis
           using wp_xs  prems  
          by (simp,metis DenyAllFromTo aux aux7 tNDComm deny_dom)
      next
         case (AllowPortFromTo a b p) thus ?thesis
             using assms wp_xs 
         by (simp, metis aux26 AllowPortFromTo Cons(4) aux aux7a tNDComm)
      next
         case (Conc a b) thus ?thesis
             using assms by (metis Conc Cons(2) singleCombinators.simps(2)) 
      qed
 qed



lemma AD_aux: "\<lbrakk>AllowPortFromTo a b po \<in> set p ;DenyAllFromTo c d \<in> set p; 
                allNetsDistinct  p ; singleCombinators p; 
        a \<noteq> c \<or> b \<noteq> d\<rbrakk>
    \<Longrightarrow> dom (C (AllowPortFromTo a b po)) \<inter> dom (C (DenyAllFromTo c d)) = {}"
apply (rule aux26)
apply (rule_tac x ="AllowPortFromTo a b po" and y = "DenyAllFromTo c d" in tND)
apply auto 
done



lemma sorted_WP2[rule_format]: "sorted p l \<longrightarrow> all_in_list p l \<longrightarrow> distinct p \<longrightarrow> 
            allNetsDistinct p \<longrightarrow> singleCombinators p \<longrightarrow> wellformed_policy2 p"
proof (induct p)
 case Nil thus ?case by simp 
next
 case (Cons a p) thus ?case
  proof (cases a)
   case DenyAll thus ?thesis using assms Cons
               by (auto intro: ANDConc singleCombinatorsConc sortedConcEnd)
  next
   case (DenyAllFromTo c d) thus ?thesis using assms Cons
     apply simp
     apply (rule impI)+
     apply (rule conjI)
     apply (rule allI)+
     apply (rule impI)+
     apply (rule deny_dom)
     apply (auto intro: aux7 tNDComm ANDConc singleCombinatorsConc sortedConcEnd) 
     done
   next
   case (AllowPortFromTo c d e) thus ?thesis using Cons assms
      apply simp
      apply (rule impI|rule conjI|rule allI)+
      apply (rule aux26)
      apply (rule_tac x = "AllowPortFromTo c d e" and
                      y = "DenyAllFromTo aa b" in tND)
      apply (assumption,simp_all)
      apply (subgoal_tac "smaller (AllowPortFromTo c d e) (DenyAllFromTo aa b) l") 	
      apply (simp split: if_splits)
      apply metis
      apply (erule sorted_is_smaller)
      apply simp_all
      apply (metis List.set.simps(2) bothNet.simps(2) in_list.simps(2)
                   in_set_in_list set_empty2)
      by (auto intro: aux7 tNDComm ANDConc singleCombinatorsConc sortedConcEnd)
   next
   case (Conc a b) thus ?thesis using Cons by simp 
   qed
qed



lemma wellformed2_sorted[simp]: "\<lbrakk>all_in_list p l; distinct p; allNetsDistinct p;
                         singleCombinators p\<rbrakk> \<Longrightarrow> wellformed_policy2 (sort p l)"
apply (rule sorted_WP2)
apply (erule sort_is_sorted, simp_all)
apply (erule all_in_listSubset)
by (auto intro: SC3 singleCombinatorsConc sorted_insort)


lemma C_DenyAll[simp]: "C (list2policy (xs @ [DenyAll])) x = Some (deny ())"
by (auto simp: PLemmas)


lemma C_eq_RS1n:
   "C(list2policy (removeShadowRules1_alternative p)) = C(list2policy p)"
apply (case_tac "p = []")
apply simp_all
apply (metis rSR1_eq removeShadowRules1.simps(2))
apply (rule rev_induct)
apply (metis rSR1_eq removeShadowRules1.simps(2))
apply (case_tac "xs = []", simp_all)
apply (simp add: removeShadowRules1_alternative_def)
apply (case_tac x, simp_all)
apply (rule ext) 
apply (case_tac "x = DenyAll")
apply (simp_all add: C_DenyAll PLemmas)
apply (rule_tac t = "removeShadowRules1_alternative (xs @ [x])" and
               s = "(removeShadowRules1_alternative xs)@[x]" in subst)
apply (erule RS1n_assoc)
apply (case_tac "xa \<in> dom (C x)")
apply simp_all
done


lemma C_eq_RS1[simp]: "p \<noteq> [] \<Longrightarrow>
                       C(list2policy (removeShadowRules1 p)) = C(list2policy p)"
by (metis rSR1_eq C_eq_RS1n)


lemma EX_MR_aux[rule_format]: "matching_rule x (DenyAll # p) \<noteq> Some DenyAll \<longrightarrow>
                               (\<exists>y. matching_rule x p = Some y)"
apply (simp add: matching_rule_def)
apply (rule_tac xs = p in rev_induct, simp_all)  
done

lemma EX_MR : "\<lbrakk>matching_rule x p \<noteq> (Some DenyAll); p = DenyAll#ps\<rbrakk> \<Longrightarrow> 
                           (matching_rule x p = matching_rule x ps)"
apply auto
apply (subgoal_tac "matching_rule x (DenyAll#ps) \<noteq> None")
apply auto
apply (metis mrConcEnd the.simps)
apply (metis DAimpliesMR_E is_in_insort saux wellformed_policy1_strong.simps(2)
             wp1_auxa)
done

lemma mr_not_DA:
  "\<lbrakk>wellformed_policy1_strong s; matching_rule x p = Some (DenyAllFromTo a ab);
    set p = set s\<rbrakk> \<Longrightarrow> matching_rule x s \<noteq> Some DenyAll"
apply (subst wp1n_tl, simp_all)
apply (subgoal_tac "x \<in> dom (C (DenyAllFromTo a ab))")
apply (subgoal_tac "DenyAllFromTo a ab \<in> set (tl s)")
apply (metis wp1n_tl foo98 wellformed_policy1_strong.simps(2))
apply (erule r_not_DA_in_tl, simp_all)
apply (subgoal_tac "DenyAllFromTo a ab \<in> set p", simp)
apply (erule mrSet)
apply (erule mr_in_dom)
done

lemma domsMT_notND_DD: 
   "\<lbrakk>dom (C (DenyAllFromTo a b)) \<inter> dom (C (DenyAllFromTo c d)) \<noteq> {}\<rbrakk> \<Longrightarrow>
     \<not> netsDistinct a c"
apply (erule contrapos_nn)
apply (simp add: C.simps)
apply (rule aux6)
apply (simp add: twoNetsDistinct_def)
done


lemma domsMT_notND_DD2: 
  "\<lbrakk>dom (C (DenyAllFromTo a b)) \<inter> dom (C (DenyAllFromTo c d)) \<noteq> {}\<rbrakk> \<Longrightarrow>
   \<not> netsDistinct b d"
apply (erule contrapos_nn)
apply (simp add: C.simps)
apply (rule aux6)
apply (simp add: twoNetsDistinct_def)
done

lemma domsMT_notND_DD3: 
  "\<lbrakk>x \<in> dom (C (DenyAllFromTo a b)); x \<in> dom (C (DenyAllFromTo c d))\<rbrakk> \<Longrightarrow>
   \<not> netsDistinct a c"
apply (rule domsMT_notND_DD)
apply auto
done

lemma domsMT_notND_DD4: 
  "\<lbrakk>x \<in> dom (C (DenyAllFromTo a b)); x \<in> dom (C (DenyAllFromTo c d))\<rbrakk> \<Longrightarrow>
   \<not> netsDistinct b d"
apply (rule domsMT_notND_DD2)
apply auto
done

lemma NetsEq_if_sameP_DD: 
  "\<lbrakk>allNetsDistinct p; u\<in> set p; v\<in> set p; u = (DenyAllFromTo a b); 
   v = (DenyAllFromTo c d); x \<in> dom (C (u)); x \<in> dom (C (v))\<rbrakk> \<Longrightarrow> 
    a = c \<and> b = d"
apply (simp add: allNetsDistinct_def)
apply (metis ND0aux1 ND0aux2 domsMT_notND_DD3 domsMT_notND_DD4 mem_def)
done


lemma rule_charn1: 
 assumes aND: "allNetsDistinct p"
 and mr_is_allow: "matching_rule x p = Some (AllowPortFromTo a b po)"
 and SC: "singleCombinators p"
 and inp: "r \<in> set p" 
 and inDom: "x \<in> dom (C r)"
 shows "(r = AllowPortFromTo a b po \<or> r = DenyAllFromTo a b \<or> r = DenyAll)"
proof (cases r) 
  case DenyAll show ?thesis  by (metis DenyAll)
next
  case (DenyAllFromTo x y) show ?thesis using Cons assms prems
     apply (simp,rule_tac  p = p and po =po in DistinctNetsDenyAllow, simp_all)
     apply (metis mrSet)
     by (metis Int_iff mr_in_dom inSet_not_MT set_empty2)
next
  case (AllowPortFromTo x y b) show ?thesis using prems Cons
     apply simp
     apply (rule DistinctNetsAllowAllow, simp_all)
     apply (metis mrSet)
     by (metis Int_iff mr_in_dom inSet_not_MT set_empty2)
next
  case (Conc x y) thus ?thesis using Cons prems by (metis aux0_0)
qed


lemma nMTRS3[simp]: "noneMT (removeShadowRules3 p)"
by (induct p) simp_all

lemma nMTcharn: "noneMT p = (\<forall> r \<in> set p. dom (C r) \<noteq> {})"
by (induct p) simp_all

lemma nMTeqSet: "set p = set s \<Longrightarrow> noneMT p = noneMT s"
by (simp add: nMTcharn)

lemma nMTSort: "noneMT p \<Longrightarrow> noneMT (sort p l)"
by (metis set_sort nMTeqSet)

lemma wp3char[rule_format]: "noneMT xs \<and>  C (AllowPortFromTo a b po) = empty \<and> 
                            wellformed_policy3 (xs @ [DenyAllFromTo a b]) \<longrightarrow> 
                             AllowPortFromTo a b po \<notin> set xs"
apply (induct xs)
apply simp_all
apply (metis wp3Conc Int_absorb1 Int_commute allow_deny_dom in_set_conv_decomp 
             not_Cons_self removeShadowRules2.simps(1) set_empty2 
             wellformed_policy3.simps(2))
done



lemma wp3charn[rule_format]: 
assumes domAllow: "dom (C (AllowPortFromTo a b po)) \<noteq> {}" 
and wp3: "wellformed_policy3 (xs @ [DenyAllFromTo a b])"
shows allowNotInList: "AllowPortFromTo a b po \<notin> set xs"
apply (insert assms)
proof (induct xs)
 case Nil show ?case by simp
next
 case (Cons x xs) show ?case using prems
 by (simp,auto intro: wp3Conc) (auto simp: DenyAllowDisj domAllow)
qed

lemma notMTnMT: "\<lbrakk>a \<in> set p; noneMT p\<rbrakk> \<Longrightarrow> dom (C a) \<noteq> {}"
by (simp add: nMTcharn)

lemma noneMTconc[rule_format]: "noneMT (a@[b]) \<longrightarrow> noneMT a"
by (induct a, simp_all)

lemma rule_charn2: 
 assumes aND: "allNetsDistinct p"
 and wp1: "wellformed_policy1 p"
 and SC: "singleCombinators p"
 and wp3: "wellformed_policy3 p"
 and allow_in_list: "AllowPortFromTo c d po \<in> set p"
 and x_in_dom_allow: "x \<in> dom (C (AllowPortFromTo c d po))"
 shows  "matching_rule x p = Some (AllowPortFromTo c d po)"
 proof  (insert prems, induct p rule: rev_induct)    
   case Nil show ?case using prems by simp
 next 
   case (snoc y ys) show ?case using prems
     apply simp
     apply (case_tac "y = (AllowPortFromTo c d po)")
     apply (simp add: matching_rule_def)
     apply simp_all
     apply (subgoal_tac "ys \<noteq> []")
     apply (subgoal_tac "matching_rule x ys = Some (AllowPortFromTo c d po)")
     defer 1
     apply (metis ANDConcEnd SCConcEnd WP1ConcEnd foo25 snoc) 
     apply (metis inSet_not_MT)
     proof (cases y)
      case DenyAll thus ?thesis using prems      
            apply simp
            by (metis DAnotTL DenyAll inSet_not_MT policy2list.simps(2))
       next
      case (DenyAllFromTo a b) thus ?thesis using prems apply simp
     apply (simp_all add: matching_rule_def)
     apply (rule conjI)
     apply (metis domInterMT  wp3EndMT)
     apply (rule impI)
     by (metis ANDConcEnd DenyAllFromTo SCConcEnd WP1ConcEnd foo25)
       next
     case (AllowPortFromTo a1 a2 b) thus ?thesis using prems apply simp
     apply (simp_all add: matching_rule_def)
     apply (rule conjI)
     apply (metis domInterMT  wp3EndMT)
 by (metis ANDConcEnd AllowPortFromTo SCConcEnd WP1ConcEnd foo25 x_in_dom_allow)
     next
     case (Conc a b) thus ?thesis using prems apply simp
        by (metis Conc aux0_0 in_set_conv_decomp) 
     qed
qed

lemma rule_charn3: 
 "\<lbrakk>wellformed_policy1 p; allNetsDistinct p; singleCombinators p; 
  wellformed_policy3 p; matching_rule x p = Some (DenyAllFromTo c d); 
  AllowPortFromTo a b po \<in> set p\<rbrakk> \<Longrightarrow> x \<notin> dom (C (AllowPortFromTo a b po))"
by (clarify, auto simp: rule_charn2 dom_def) 

lemma rule_charn4: 
assumes wp1: "wellformed_policy1 p" 
and aND: "allNetsDistinct p" 
and SC: "singleCombinators p"
and wp3: "wellformed_policy3 p"  
and DA: "DenyAll \<notin> set p" 
and mr: "matching_rule x p = Some (DenyAllFromTo a b)"
and rinp: "r \<in> set p"
and xindom: "x \<in> dom (C r)"
shows "r = DenyAllFromTo a b"
proof (cases r)
  case DenyAll thus ?thesis using prems by simp 
next
  case (DenyAllFromTo c d) thus ?thesis using prems apply simp
    apply (erule_tac x = x and p = p and v = "(DenyAllFromTo a b)" and
                     u = "(DenyAllFromTo c d)"  in NetsEq_if_sameP_DD)
    apply simp_all
    apply (erule mrSet)
    by (erule mr_in_dom) 
next
  case (AllowPortFromTo c d e) thus ?thesis using prems apply simp
    apply (subgoal_tac "x \<notin> dom (C  (AllowPortFromTo c d e))")
    apply simp 
    apply (rule_tac p = p in rule_charn3)
    by (auto intro: SCnotConc) 
next
  case (Conc a b) thus ?thesis using prems apply simp
      by (metis Conc aux0_0 in_set_conv_decomp) 
qed


lemma nMTtail[rule_format]: "noneMT p \<longrightarrow> noneMT (tl p)"
by (induct p, simp_all)


lemma foo31a: "\<lbrakk>(\<forall> r. r \<in> set p \<and> x \<in> dom (C r) \<longrightarrow>
           (r = AllowPortFromTo a b po \<or> r = DenyAllFromTo a b \<or> r = DenyAll));
           set p = set s; r \<in> set s ; x \<in> dom (C r)\<rbrakk> \<Longrightarrow>
           (r = AllowPortFromTo a b po \<or> r = DenyAllFromTo a b \<or> r = DenyAll)"
by auto


lemma aux4[rule_format]: 
  "matching_rule x (a#p) = Some a \<longrightarrow> a \<notin> set (p) \<longrightarrow> matching_rule x p = None"
apply (rule rev_induct)
apply simp_all
apply (rule impI)+
apply simp
apply (simp add: matching_rule_def)
apply (simp split: if_splits)
done

lemma mrDA_tl: 
 assumes mr_DA: "matching_rule x p = Some DenyAll"
 and wp1n: "wellformed_policy1_strong p"
 shows "matching_rule x (tl p) = None"
 apply (rule aux4 [where a = DenyAll])
 apply (metis wp1n_tl mr_DA wp1n)
 by (metis WP1n_DA_notinSet wp1n)

lemma rule_charnDAFT: 
"\<lbrakk>wellformed_policy1_strong p; allNetsDistinct p; singleCombinators p; 
  wellformed_policy3 p; matching_rule x p = Some (DenyAllFromTo a b);
  r \<in> set (tl p); x \<in> dom (C r)\<rbrakk> \<Longrightarrow> r = DenyAllFromTo a b"
apply (subgoal_tac "p = DenyAll#(tl p)")
apply (rule_tac p = "tl p" in rule_charn4)
apply simp_all
apply (metis wellformed_policy1_strong.simps(1) wp1_eq wp1_tl)
apply (erule AND_tl)
apply (erule SC_tl)
apply (erule wp3tl)
apply (erule WP1n_DA_notinSet)
apply (metis Combinators.simps(4) DAAux EX_MR matching_rule_def matching_rule_rev.simps(1) mrSet option.inject rev_rev_ident set_rev tl.simps(2) wellformed_policy1_charn wp1_eq)
apply (metis  wp1n_tl) 
done

lemma mrDenyAll_is_unique: 
  "\<lbrakk>wellformed_policy1_strong p; matching_rule x p = Some DenyAll;
   r \<in> set (tl p)\<rbrakk> \<Longrightarrow> x \<notin> dom (C r)"
apply (rule_tac a = "[]" and b = "DenyAll" and c = "tl p"  in foo3a, simp_all)  
apply (metis wp1n_tl)
by (metis WP1n_DA_notinSet)


theorem  C_eq_Sets_mr: 
 assumes sets_eq: "set p = set s"
 and SC: "singleCombinators p"
 and wp1_p: "wellformed_policy1_strong p"
 and wp1_s: "wellformed_policy1_strong s"
 and wp3_p: "wellformed_policy3 p"       
 and wp3_s: "wellformed_policy3 s"  
 and aND: "allNetsDistinct p"        
   
 shows "matching_rule x p = matching_rule x s"
proof (cases "matching_rule x p")

 case None 
     have DA: "DenyAll \<in> set p" using wp1_p by (auto simp: wp1_aux1aa)
     have notDA: "DenyAll \<notin> set p" using None by (auto simp: DAimplieMR) 
     thus ?thesis using DA by (contradiction)
 next
 
 case (Some y) thus ?thesis
   proof (cases y) 
      have tl_p: "p = DenyAll#(tl p)" by (metis wp1_p wp1n_tl) 
      have tl_s: "s = DenyAll#(tl s)" by (metis wp1_s wp1n_tl)
      have tl_eq: "set (tl p) = set (tl s)"
       by (metis tl.simps(2) WP1n_DA_notinSet sets_eq foo2
                 wellformed_policy1_charn wp1_aux1aa wp1_eq wp1_p wp1_s)
    {
   case DenyAll
     have mr_p_is_DenyAll: "matching_rule x p = Some DenyAll"
        by (simp add: DenyAll Some)
     hence x_notin_tl_p: "\<forall> r. r \<in> set (tl p) \<longrightarrow>  x \<notin> dom (C r)" using wp1_p
        by (auto simp: mrDenyAll_is_unique)
     hence x_notin_tl_s: "\<forall> r. r \<in> set (tl s) \<longrightarrow>  x \<notin> dom (C r)" using tl_eq
        by auto
     hence mr_s_is_DenyAll: "matching_rule x s = Some DenyAll" using tl_s
        by (auto simp: mr_first)
     thus ?thesis using mr_p_is_DenyAll by simp
}
{   case (DenyAllFromTo a b) 
     have mr_p_is_DAFT: "matching_rule x p = Some (DenyAllFromTo a b)"
        by (simp add: DenyAllFromTo Some)
     have DA_notin_tl: "DenyAll \<notin> set (tl p)"
        by (metis WP1n_DA_notinSet wp1_p)
     have mr_tl_p: "matching_rule x p = matching_rule x (tl p)"
        by (metis Combinators.simps(4) DenyAllFromTo Some mrConcEnd tl_p)
     have dom_tl_p: "\<And> r. r \<in> set (tl p) \<and> x \<in> dom (C r) \<Longrightarrow> 
                     r = (DenyAllFromTo a b)"
       using wp1_p aND SC wp3_p mr_p_is_DAFT
       by (auto simp: rule_charnDAFT)
     hence dom_tl_s: "\<And> r. r \<in> set (tl s) \<and> x \<in> dom (C r) \<Longrightarrow> 
                      r = (DenyAllFromTo a b)"
       using tl_eq  by auto
     have DAFT_in_tl_s: "DenyAllFromTo a b \<in> set (tl s)" using mr_tl_p
       by (metis DenyAllFromTo mrSet mr_p_is_DAFT tl_eq)
     have x_in_dom_DAFT: "x \<in> dom (C (DenyAllFromTo a b))"
       by (metis mr_p_is_DAFT DenyAllFromTo mr_in_dom)
     hence mr_tl_s_is_DAFT: "matching_rule x (tl s) = Some (DenyAllFromTo a b)"
       using DAFT_in_tl_s dom_tl_s  by (auto simp: mr_charn)
     hence mr_s_is_DAFT: "matching_rule x s = Some (DenyAllFromTo a b)"
       using tl_s
          by (metis  DA_notin_tl DenyAllFromTo EX_MR mrDA_tl mr_p_is_DAFT
                      not_Some_eq tl_eq wellformed_policy1_strong.simps(2))
     thus ?thesis using mr_p_is_DAFT by simp
}
{  case (AllowPortFromTo a b c)
     have wp1s: "wellformed_policy1 s" by (metis wp1_eq wp1_s)
     have mr_p_is_A: "matching_rule x p = Some (AllowPortFromTo a b c)"
       by (simp add: AllowPortFromTo Some)
     hence A_in_s: "AllowPortFromTo a b c \<in> set s" using sets_eq
       by (auto intro: mrSet)
     have x_in_dom_A: "x \<in> dom (C (AllowPortFromTo a b c))"
       by (metis mr_p_is_A AllowPortFromTo mr_in_dom)
     have SCs: "singleCombinators s" using SC sets_eq
       by (auto intro: SCSubset)
     hence ANDs: "allNetsDistinct s" using aND sets_eq SC
       by (auto intro: aNDSetsEq)
     hence mr_s_is_A: "matching_rule x s = Some (AllowPortFromTo a b c)"
       using A_in_s wp1s mr_p_is_A aND SCs wp3_s x_in_dom_A
          by (simp add: rule_charn2)
     thus ?thesis using mr_p_is_A by simp
}
    case (Conc a b) thus ?thesis by (metis Some mr_not_Conc SC) 
 qed
qed

lemma C_eq_Sets: 
"\<lbrakk>singleCombinators p; wellformed_policy1_strong p; wellformed_policy1_strong s;
wellformed_policy3 p; wellformed_policy3 s; allNetsDistinct p; set p = set s\<rbrakk> \<Longrightarrow>
  C (list2policy p) x  = C (list2policy s) x"
  apply (rule C_eq_if_mr_eq)
  apply (rule C_eq_Sets_mr [symmetric])
  apply simp_all
done

lemma C_eq_sorted: "\<lbrakk>distinct p; all_in_list p l; singleCombinators p;
        wellformed_policy1_strong p; wellformed_policy3 p; allNetsDistinct p\<rbrakk> \<Longrightarrow>
        C (list2policy (sort p l))= C (list2policy p)"
 apply (rule ext)
 apply (rule C_eq_Sets)
 apply (auto simp: nMTSort wellformed1_alternative_sorted
                  wellformed_policy3_charn wellformed1_sorted wp1_eq)
done



lemma mrconc[rule_format]: "matching_rule x p = Some a \<longrightarrow>
                            matching_rule x (b#p) = Some a"
apply (rule rev_induct)  back 
apply (simp)
apply (rule impI)
apply (case_tac "x \<in> dom (C xa)")
apply (simp_all add: matching_rule_def)
done

lemma mreq_end: "\<lbrakk>matching_rule x b = Some r; matching_rule x c = Some r\<rbrakk> \<Longrightarrow> 
 matching_rule x (a#b) = matching_rule x (a#c)"
by (simp add: mrconc)

lemma mrconcNone[rule_format]: "matching_rule x p = None \<longrightarrow>
                                matching_rule x (b#p) = matching_rule x [b]"
apply (rule_tac xs = p in rev_induct) 
apply simp_all
apply (rule impI)
apply (case_tac "x \<in> dom (C xa)")
apply (simp_all add: matching_rule_def)
done

lemma mreq_endNone: "\<lbrakk>matching_rule x b = None; matching_rule x c = None\<rbrakk> \<Longrightarrow> 
     matching_rule x (a#b) = matching_rule x (a#c)"
by (metis mrconcNone)

lemma mreq_end2: "matching_rule x b = matching_rule x c \<Longrightarrow> 
     matching_rule x (a#b) = matching_rule x (a#c)"
apply (case_tac "matching_rule x b = None")
apply (auto intro: mreq_end mreq_endNone)
done

lemma mreq_end3: "matching_rule x p \<noteq> None \<Longrightarrow>
                  matching_rule x (b # p) = matching_rule x (p)"
by (auto simp: mrconc)

lemma mrNoneMT[rule_format]: "r \<in> set p \<longrightarrow> matching_rule x p = None \<longrightarrow>
                              x \<notin> dom (C r)"
apply (rule rev_induct, simp_all)
apply (rule conjI| rule impI)+
apply simp_all
apply (case_tac "xa \<in> set xs")
apply (simp_all add: matching_rule_def split: if_splits)
done

lemma C_eq_RS2_mr: "matching_rule x (removeShadowRules2 p)= matching_rule x p"
proof (induct p)
 case Nil thus ?case by simp next
 case (Cons y ys) thus ?case
 proof (cases "ys = []")
  case True thus ?thesis by (cases y, simp_all) next
  case False thus ?thesis
   proof (cases y)
    case DenyAll thus ?thesis by (simp, metis Cons DenyAll mreq_end2) next
    case (DenyAllFromTo a b) thus ?thesis
        by (simp, metis Cons DenyAllFromTo mreq_end2)
     next
    case (AllowPortFromTo a b p) thus ?thesis
      proof (cases "DenyAllFromTo a b \<in> set ys")
        case True thus ?thesis using prems
          apply (cases "matching_rule x ys = None", simp_all)
          apply (subgoal_tac "x \<notin> dom (C (AllowPortFromTo a b p))")
          apply (subst mrconcNone, simp_all)
          apply (simp add: matching_rule_def )
          apply (rule contra_subsetD [OF allow_deny_dom])
          apply (erule mrNoneMT,simp)
          apply (metis AllowPortFromTo mrconc)
          done
        next
        case False thus ?thesis using prems
                     by (simp, metis AllowPortFromTo Cons mreq_end2) qed
    next
    case (Conc a b) thus ?thesis
                      by (metis Cons mreq_end2 removeShadowRules2.simps(4))
   qed
  qed
qed



lemma C_eq_None[rule_format]: "p \<noteq> []  --> matching_rule x p = None \<longrightarrow>
                               C (list2policy p) x = None"
apply (simp add: matching_rule_def)
apply (rule rev_induct, simp_all)
apply (rule impI)+
apply simp
apply (case_tac "xs \<noteq> []")
apply (simp_all add: dom_def)
done

lemma C_eq_None2:
  "\<lbrakk>a \<noteq> []; b \<noteq> []; matching_rule x a = None; matching_rule x b = None\<rbrakk> \<Longrightarrow>
  (C (list2policy a)) x = (C (list2policy b)) x"
by (auto simp: C_eq_None)

lemma C_eq_RS2: "wellformed_policy1_strong p \<Longrightarrow> 
 C (list2policy (removeShadowRules2 p))= C (list2policy p)"
apply (rule ext)
apply (rule C_eq_if_mr_eq)
apply (rule C_eq_RS2_mr [symmetric], simp_all)
apply (metis wp1_alternative_not_mt wp1n_RS2)
done



lemma noneMTsubset[rule_format]: "noneMT a \<longrightarrow> set b \<subseteq> set a \<longrightarrow> noneMT b"
apply (induct b,simp_all)
by (metis dom_empty notMTnMT)

lemma noneMTRS2: "noneMT p \<Longrightarrow> noneMT (removeShadowRules2 p)"
by (auto simp: RS2Set noneMTsubset)

lemma CconcNone: "\<lbrakk>dom (C a) = {}; p \<noteq> []\<rbrakk> \<Longrightarrow>
                  C (list2policy (a # p)) x = C (list2policy p) x"
apply (case_tac "p = []", simp_all)
apply (case_tac "x\<in> dom (C (list2policy(p)))")
apply (metis Cdom2 list2policyconc mem_def)
apply (metis C.simps(4) map_add_dom_app_simps domIff inSet_not_MT list2policyconc set_empty2)
done

lemma notMTpolicyimpnotMT[simp]: "notMTpolicy p \<Longrightarrow> p \<noteq> []"
by auto

lemma SR3nMT[rule_format]: "\<not> notMTpolicy p \<longrightarrow> removeShadowRules3 p = []"
by (induct p, simp_all)


lemma noneMTrd[rule_format]: "noneMT p \<longrightarrow> noneMT (remdups p)"
by (induct p, simp_all)

lemma DARS3[rule_format]:"DenyAll \<notin> set p\<longrightarrow>DenyAll \<notin> set (removeShadowRules3 p)"
by (induct p, simp_all)

lemma DAnMT: "dom (C DenyAll) \<noteq> {}"
by (simp add: dom_def C.simps PolicyCombinators.PolicyCombinators)

lemma DAnMT2: "C DenyAll \<noteq> empty"
by (metis DAAux PLemmas(1) dom_eq_empty_conv empty_iff) 




lemma wp1n_RS3[rule_format,simp]: "wellformed_policy1_strong p \<longrightarrow>
                               wellformed_policy1_strong (removeShadowRules3 p)"
apply (induct p, simp_all)
apply (rule conjI| rule impI|simp)+
apply (metis DAnMT)
apply (metis DARS3) 
done

lemma AILRS3[rule_format,simp]: "all_in_list p l \<longrightarrow>
                                 all_in_list (removeShadowRules3 p) l"
by (induct p, simp_all)

lemma SCRS3[rule_format,simp]: "singleCombinators p \<longrightarrow>
                                singleCombinators(removeShadowRules3 p)"
apply (induct p, simp_all)
apply (case_tac "a", simp_all)
done


lemma RS3subset: "set (removeShadowRules3 p)  \<subseteq> set p "
by (induct p, auto)


lemma ANDRS3[simp]: "\<lbrakk>singleCombinators p; allNetsDistinct p\<rbrakk> \<Longrightarrow>
                     allNetsDistinct (removeShadowRules3 p)"
apply (rule_tac b = p in aNDSubset)
apply simp_all
apply (rule RS3subset)
done

lemma nlpaux: "x \<notin> dom (C b) \<Longrightarrow> C (a \<oplus> b) x = C a x"
by (metis C.simps(4) map_add_dom_app_simps(3))

lemma notindom[rule_format]: "a \<in> set p \<longrightarrow>  x \<notin> dom (C (list2policy p)) \<longrightarrow>
                             x \<notin> dom (C a)"
apply (induct p)
apply simp_all
apply (rule conjI| rule impI)+
apply (metis CConcStartA)
apply (rule impI)+
apply simp
apply (metis CConcStartA Cdom2 List.set.simps(2) domIff insert_absorb list.simps(2) list2policyconc set_empty)
done

lemma C_eq_rd[rule_format]: "p \<noteq> [] \<Longrightarrow>
                            C (list2policy (remdups p)) = C (list2policy p)"
apply (rule ext)
proof (induct p) 
  case Nil thus ?case by simp next
  case (Cons y ys) thus ?case
    proof (cases "ys = []")
      case True thus ?thesis by simp next
      case False thus ?thesis using prems apply simp
       apply (rule conjI, rule impI)
       apply (cases "x \<in> dom (C (list2policy ys))")
       apply (metis Cdom2 False list2policyconc mem_def)
       apply (metis False domIff list2policyconc nlpaux notindom)
       apply (rule impI)
       apply (cases "x \<in> dom (C (list2policy ys))")
       apply (subgoal_tac "x \<in> dom (C (list2policy (remdups ys)))")
       apply (metis Cdom2 False list2policyconc remdups_eq_nil_iff)
       apply (metis domIff)
       apply (subgoal_tac "x \<notin> dom (C (list2policy (remdups ys)))")
       apply (metis False list2policyconc nlpaux remdups_eq_nil_iff)
       apply (metis domIff)
       done
  qed
qed
   
lemma RS3nMT[rule_format]: "notMTpolicy p \<longrightarrow> notMTpolicy (removeShadowRules3 p)"
by (induct p,simp_all)


lemma nMT_domMT: "\<lbrakk>\<not> notMTpolicy p; p \<noteq> []\<rbrakk> \<Longrightarrow> r \<notin> dom (C (list2policy p))"
 proof (induct p)
   case Nil thus ?case by simp next
   case (Cons x xs) thus ?case apply simp
      apply (simp split: if_splits)
      apply (cases "xs = []")
      apply (simp_all add:dom_empty)
by (metis CconcNone domIff)
qed
            
lemma C_eq_RS3_aux[rule_format]: "notMTpolicy p \<Longrightarrow>
                  C (list2policy p) x = C (list2policy (removeShadowRules3 p)) x"
proof (induct p)
 case Nil thus ?case by simp next
 case (Cons y ys) thus ?case
   proof (cases "notMTpolicy ys")
     case True thus ?thesis using prems apply simp
     apply (rule conjI, rule impI, simp)
     apply (metis CconcNone True dom_empty notMTpolicyimpnotMT)
     apply (rule impI, simp)
     apply (cases "x \<in> dom (C (list2policy ys))")
     apply (subgoal_tac "x \<in> dom (C (list2policy (removeShadowRules3 ys)))")
     apply (metis Cdom2 RS3nMT True list2policyconc notMTpolicyimpnotMT)
     apply (simp add: domIff)
     apply (subgoal_tac "x \<notin>  dom (C (list2policy (removeShadowRules3 ys)))")
     apply (metis RS3nMT True list2policyconc nlpaux notMTpolicyimpnotMT)
     apply (metis domIff)
     done
     next 
     case False thus ?thesis using prems
        proof (cases "ys = []")
          case True thus ?thesis using prems by (simp) (rule impI, simp) next
          case False thus ?thesis using prems apply (simp)
            apply (rule conjI| rule impI| simp)+
            apply (subgoal_tac "removeShadowRules3 ys = []")
            apply simp_all
            apply (subgoal_tac "x \<notin> dom (C (list2policy ys))")
            apply (metis False list2policyconc nlpaux)
            apply (erule nMT_domMT, simp_all)
            by (metis SR3nMT)
        qed
     qed
qed       



lemma C_eq_id: "wellformed_policy1_strong p \<Longrightarrow>
                C(list2policy (insertDeny p)) = C (list2policy p)"
apply (rule ext)
apply (rule C_eq_if_mr_eq)
apply simp_all
apply (erule mr_iD)
done

lemma C_eq_RS3: "notMTpolicy p \<Longrightarrow>
                 C(list2policy (removeShadowRules3 p)) = C (list2policy p)"
apply (rule ext)
by (erule C_eq_RS3_aux[symmetric])

lemma NMPcharn[rule_format]: "a \<in> set p\<longrightarrow> dom (C a) \<noteq> {} \<longrightarrow> notMTpolicy p"
by (induct p, simp_all)


lemma NMPrd[rule_format]: "notMTpolicy p \<longrightarrow> notMTpolicy (remdups p)"
apply (induct p, simp_all)
by (auto simp: NMPcharn)

lemma NMPRS3[rule_format]: "notMTpolicy p \<longrightarrow> notMTpolicy (removeShadowRules3 p)"
by (induct p, simp_all)


lemma NMPDA[rule_format]: "DenyAll \<in> set p \<longrightarrow> notMTpolicy p"
by (induct p, simp_all add: DAnMT)


lemma NMPiD[rule_format]: "notMTpolicy (insertDeny p)"
apply (insert DAiniD [of p])
apply (erule NMPDA)
done



lemma list2policy2list[rule_format]: "C (list2policy(policy2list p)) = (C p)"
apply (rule ext)
apply (induct_tac p, simp_all)
apply (case_tac "x \<in> dom (C (Combinators2))") 
apply (metis Cdom2 CeqEnd domIff p2lNmt)
apply (metis CeqStart domIff p2lNmt nlpaux)
done



lemmas C_eq_Lemmas = noneMTRS2 noneMTrd distinct_remdups SC2 SCrd SCRS3 SCRiD SC1 SCp2l
              wp1n_RS2 WP1rd WP2RS2 wp1n_RS3 wp1ID NMPiD wp1alternative_RS1
              p2lNmt list2policy2list wellformed_policy3_charn waux2 wp1_eq

lemmas C_eq_subst_Lemmas = C_eq_sorted C_eq_RS2 C_eq_rd C_eq_RS3 C_eq_id 

lemma C_eq_All_untilSorted: 
"\<lbrakk>DenyAll \<in> set (policy2list p);  all_in_list (policy2list p) l;
  allNetsDistinct (policy2list p)\<rbrakk> \<Longrightarrow>
  C(list2policy (sort (removeShadowRules2 (remdups (removeShadowRules3
    (insertDeny (removeShadowRules1  (policy2list p)))))) l)) = C p"
apply (subst C_eq_sorted)
apply (simp_all add: C_eq_Lemmas)
apply (subst C_eq_RS2)
apply (simp_all add: C_eq_Lemmas) 
apply (subst C_eq_rd)
apply (simp_all add: C_eq_Lemmas)
apply (subst C_eq_RS3)
apply (simp_all add: C_eq_Lemmas)
apply (subst C_eq_id)
apply (simp_all add: C_eq_Lemmas)
done


(* or, even shorter *)

lemma C_eq_All_untilSorted_withSimps: 
"\<lbrakk>DenyAll \<in> set (policy2list p);  all_in_list (policy2list p) l;
 allNetsDistinct (policy2list p)\<rbrakk> \<Longrightarrow>
 C(list2policy (sort (removeShadowRules2 (remdups (removeShadowRules3 (insertDeny
   (removeShadowRules1  (policy2list p)))))) l)) = C p"
by (simp_all add: C_eq_Lemmas C_eq_subst_Lemmas)




lemma InDomConc[rule_format]: "p \<noteq> [] \<longrightarrow> x \<in> dom (C (list2policy (p))) \<longrightarrow>
                               x \<in>  dom (C (list2policy (a#p)))"
apply (induct p)
apply simp_all
apply (case_tac "p = []")
apply (simp_all add: dom_def C.simps)
done

lemma not_in_member[rule_format]: "member a b \<longrightarrow> x \<notin> dom (C b) \<longrightarrow> x \<notin> dom (C a)"
apply (induct b)
apply (simp_all add: dom_def C.simps)
done



lemma src_in_sdnets[rule_format]: "\<not> member DenyAll x \<longrightarrow> p \<in> dom (C x) \<longrightarrow>
                             subnetsOfAdr (src p) \<inter> (fst_set (sdnets x)) \<noteq> {}"
apply (induct rule: Combinators.induct)
apply simp
apply (simp add: fst_set_def subnetsOfAdr_def PLemmas)
apply (simp add: fst_set_def subnetsOfAdr_def PLemmas)
apply (rule impI)+
apply (simp add: fst_set_def)
apply (case_tac "p \<in> dom (C Combinators2)")
apply simp_all
apply (rule subnetAux)
apply assumption
apply (auto simp: PLemmas)
done

lemma dest_in_sdnets[rule_format]: "\<not> member DenyAll x \<longrightarrow> p \<in> dom (C x) \<longrightarrow>
                              subnetsOfAdr (dest p) \<inter> (snd_set (sdnets x)) \<noteq> {}"
apply (induct rule: Combinators.induct)
apply simp
apply (simp add: snd_set_def subnetsOfAdr_def PLemmas)
apply (simp add: snd_set_def subnetsOfAdr_def PLemmas)
apply (rule impI)+
apply (simp add: snd_set_def)
apply (case_tac "p \<in> dom (C Combinators2)")
apply simp_all
apply (rule subnetAux)
apply assumption
apply (auto simp: PLemmas)
done



lemma sdnets_in_subnets[rule_format]: "p\<in> dom (C x) \<longrightarrow> \<not> member DenyAll x \<longrightarrow>
        (\<exists> (a,b)\<in>sdnets x. a \<in> subnetsOfAdr (src p) \<and> b \<in> subnetsOfAdr (dest p))"
apply (rule Combinators.induct)
apply simp_all
apply (simp add: PLemmas subnetsOfAdr_def)
apply (simp add: PLemmas subnetsOfAdr_def)
apply (rule impI)+
apply simp
apply (case_tac "p \<in> dom (C (Combinators2))")
apply simp_all
apply (auto simp: PLemmas subnetsOfAdr_def)
done

lemma disjSD_no_p_in_both[rule_format]:   
 "\<lbrakk>disjSD_2 x y; \<not> member DenyAll x; \<not> member DenyAll y;  
   p \<in> dom (C x); p \<in> dom (C y)\<rbrakk> \<Longrightarrow> False"
apply (rule_tac A = "sdnets x" and B = "sdnets y" and D = "src p"
             and F = "dest p" in tndFalse)
by (auto simp: dest_in_sdnets src_in_sdnets sdnets_in_subnets disjSD_2_def)

lemma list2policy_eq: "zs \<noteq> [] \<Longrightarrow>
             C (list2policy (x \<oplus> y # z)) p = C (x \<oplus> list2policy (y # z)) p"
apply (metis C.simps(4) CConcStartaux C_eq_None C_eq_RS3 C_eq_if_mr_eq C_eq_rd 
             Cdom2 ConcAssoc domIff in_set_conv_decomp l2p_aux2 list.simps(1)
             list2policy.simps(2) list2policyconc map_add_None mrMTNone
             mrconcNone mreq_end3 mreq_endNone nlpaux not_Cons_self
             remdups.simps(2) removeShadowRules3.simps(2) self_append_conv2)
done



lemma dom_sep[rule_format]: "x \<in> dom (C (list2policy p)) \<longrightarrow>
                             x \<in> dom (C (list2policy(separate p)))"
apply (rule separate.induct) back
apply simp_all
apply (rule conjI)
apply (rule impI)+
apply simp
apply (thin_tac "False \<Longrightarrow> ?S")
apply (drule mp)
apply (case_tac "x \<in> dom (C (DenyAllFromTo v va))")
apply (metis CConcStartA domIff eq_Nil_appendI in_set_conv_decomp l2p_aux2
             list2policyconc not_Cons_self notindom)
apply (subgoal_tac "x \<in> dom (C (list2policy (y #z)))")
apply (metis CConcStartA Cdom2 InDomConc domIff l2p_aux2 list2policyconc nlpaux)
apply (subgoal_tac "x \<in> dom (C (list2policy ((DenyAllFromTo v va)#y#z)))")
apply (simp add: dom_def C.simps)
apply simp
apply simp
apply (rule impI)+
apply simp
apply (thin_tac "False \<Longrightarrow> ?S")
apply (case_tac "x \<in> dom (C (DenyAllFromTo v va))")
apply simp_all
apply (subgoal_tac "x \<in> dom (C (list2policy (y #z)))")
apply (metis InDomConc sepnMT list.simps(2))
apply (subgoal_tac "x \<in> dom (C (list2policy ((DenyAllFromTo v va)#y#z)))")
apply (simp add: dom_def C.simps)
apply simp
apply (rule impI | rule conjI)+
apply simp
apply (case_tac "x \<in> dom (C (AllowPortFromTo v va vb))")
apply (metis CConcStartA domIff eq_Nil_appendI in_set_conv_decomp l2p_aux2
            list2policyconc not_Cons_self notindom)
apply (subgoal_tac "x \<in> dom (C (list2policy (y #z)))")
apply simp
apply (metis CConcStartA Cdom2 InDomConc domIff l2p_aux2 list2policyconc nlpaux)
apply (simp add: dom_def C.simps)
apply (rule impI)+
apply simp
apply (case_tac "x \<in> dom (C (AllowPortFromTo v va vb))")
apply (metis CConcStartA)
apply (metis CConcStartA InDomConc domIff list.simps(1) list2policy.simps(2)
             nlpaux sepnMT)
apply (rule conjI | rule impI)+
apply simp
apply (thin_tac "False \<Longrightarrow> ?S")
apply (drule mp)
apply (case_tac "x \<in> dom (C ((v \<oplus> va)))")
apply (metis C.simps(4) CConcStartA ConcAssoc domIff eq_Nil_appendI
    in_set_conv_decomp list2policy2list list2policyconc notindom p2lNmt)
defer 1
apply simp_all
apply (rule impI)+
apply simp
apply (thin_tac "False \<Longrightarrow> ?S")
apply (case_tac "x \<in> dom (C ((v \<oplus> va)))")
apply (metis CConcStartA)
apply (drule mp)
apply (simp add: C.simps dom_def)
apply (metis InDomConc list.simps(2)sepnMT)
apply (subgoal_tac "x \<in> dom (C (list2policy (y#z)))")
apply (case_tac "x \<in> dom (C y)")
apply simp_all
apply (metis CConcStartA Cdom2 ConcAssoc domIff mem_def)
apply (metis InDomConc domIff l2p_aux2 list2policyconc nlpaux)
apply (case_tac "x \<in> dom (C y)")
apply simp_all
apply (metis InDomConc domIff l2p_aux2 list2policyconc nlpaux)
done

lemma domdConcStart[rule_format]: "   x \<in> dom (C (list2policy (a#b))) \<longrightarrow>
        x \<notin> dom (C (list2policy b))
       \<longrightarrow> x \<in> dom (C (a))"
apply (induct b, simp_all)
apply (auto simp: PLemmas)
done

lemma sep_dom2_aux: "\<lbrakk>x \<in> dom (C (list2policy (a \<oplus> y # z)))\<rbrakk>
       \<Longrightarrow> x \<in> dom (C (a \<oplus> list2policy (y # z)))"
by (metis CConcStartA InDomConc domIff domdConcStart l2p_aux2 list.simps(2) 
          list2policy.simps(2) nlpaux)

lemma sep_dom2_aux2: 
"\<lbrakk>(x \<in> dom (C (list2policy (separate (y # z)))) \<longrightarrow>
    x \<in> dom (C (list2policy (y # z))));
   x \<in> dom (C (list2policy (a # separate (y # z))))\<rbrakk>
\<Longrightarrow> x \<in> dom (C (list2policy (a \<oplus> y # z)))"
by (metis CConcStartA Cdom2 InDomConc domIff domdConcStart l2p_aux l2p_aux2 nlpaux)

lemma sep_dom2[rule_format]: 
 "x \<in> dom (C (list2policy (separate p))) \<longrightarrow> x \<in> dom (C (list2policy( p)))"
apply (rule separate.induct)
by (simp_all add: sep_dom2_aux sep_dom2_aux2)

lemma sepDom: "dom (C (list2policy p)) = dom (C (list2policy (separate p)))"
apply (rule equalityI)
by (rule subsetI, (erule dom_sep|erule sep_dom2))+

lemma C_eq_s_ext[rule_format]: "p \<noteq> [] \<longrightarrow>
                         C (list2policy (separate p)) a  = C (list2policy p) a "
 proof (induct rule: separate.induct) 
  case goal1 thus ?case 
    apply simp
     apply (cases "x = []")
     apply (metis l2p_aux2 separate.simps(5))
     apply simp
     apply (cases "a \<in> dom (C (list2policy x))")
     apply (subgoal_tac "a \<in> dom (C (list2policy (separate x)))")
     apply (metis Cdom2 list2policyconc sepDom sepnMT)
     apply (metis sepDom)
     apply (subgoal_tac "a \<notin> dom (C (list2policy (separate x)))")
     apply (subst list2policyconc) 
     apply (simp add: sepnMT)
     apply (subst list2policyconc) 
     apply (simp add: sepnMT)
     apply (metis nlpaux sepDom)
     apply (metis sepDom)
     done
  next
  case goal2 thus ?case 
     apply simp 
     apply (cases "z = []")
     apply simp_all
     apply (rule conjI|rule impI|simp)+
     apply (subst list2policyconc)
      apply (metis not_Cons_self sepnMT)
     apply (metis C.simps(4) CConcStartaux Cdom2 domIff)
     apply (rule conjI|rule impI|simp)+
     apply (erule list2policy_eq)
     apply (rule impI, simp)
     apply (subst list2policyconc) 
     apply (metis list.simps(2) sepnMT) 
     by (metis C.simps(4) CConcStartaux Cdom2 domIff)
  next
  case goal3 thus ?case
  apply simp 
     apply (cases "z = []")
     apply simp_all
     apply (rule conjI|rule impI|simp)+
     apply (subst list2policyconc)
      apply (metis not_Cons_self sepnMT)
     apply (metis C.simps(4) CConcStartaux Cdom2 domIff)
     apply (rule conjI|rule impI|simp)+
     apply (erule list2policy_eq)
     apply (rule impI, simp)
     apply (subst list2policyconc) 
     apply (metis list.simps(2) sepnMT) 
     by (metis C.simps(4) CConcStartaux Cdom2 domIff)
  next
  case goal4 thus ?case
  apply simp 
     apply (cases "z = []")
     apply simp_all
     apply (rule conjI|rule impI|simp)+
     apply (subst list2policyconc)
      apply (metis not_Cons_self sepnMT)
     apply (metis C.simps(4) CConcStartaux Cdom2 domIff)
     apply (rule conjI|rule impI|simp)+
     apply (erule list2policy_eq)
     apply (rule impI, simp)
     apply (subst list2policyconc) 
     apply (metis list.simps(2) sepnMT) 
     by (metis C.simps(4) CConcStartaux Cdom2 domIff)
   next
  case goal5 thus ?case by simp next
  case goal6 thus ?case by simp next
  case goal7 thus ?case by simp next
  case goal8 thus ?case by simp next
 qed

lemma C_eq_s: "p \<noteq> [] \<Longrightarrow> C (list2policy (separate p)) = C (list2policy p)  "
apply (rule ext)
apply (rule C_eq_s_ext)
apply simp
done



lemmas C_eq_Lemmas_sep =
       C_eq_Lemmas sortnMT RS2_NMT notMTpolicyimpnotMT NMPrd NMPRS3 NMPiD


lemma C_eq_until_separated:
"\<lbrakk>DenyAll \<in> set (policy2list p); all_in_list (policy2list p) l;
  allNetsDistinct (policy2list p)\<rbrakk> \<Longrightarrow>
 C (list2policy (separate (sort (removeShadowRules2 (remdups (removeShadowRules3
  (insertDeny (removeShadowRules1 (policy2list p)))))) l))) = C p"
apply (subst  C_eq_s)
apply (simp_all add: C_eq_Lemmas_sep)
apply (rule C_eq_All_untilSorted)
apply simp_all
done



lemma domID[rule_format]: "p \<noteq> [] \<and> x \<in> dom(C(list2policy p)) \<longrightarrow>
                           x \<in> dom (C(list2policy(insertDenies p)))"
proof(induct p)
  case Nil then show ?case by simp
next 
  case (Cons a p) then show ?case
    proof(cases "p=[]")
       case goal1 then show ?case
          apply(simp) apply(rule impI)
          apply (cases a, simp_all)
          apply (simp add: C.simps dom_def)+
          apply (metis domIff Cdom2 ConcAssoc)
          done
    next
       case goal2 then show ?case
         proof(cases "x \<in> dom(C(list2policy p))")
            case goal1 then show ?case
               apply simp apply (rule impI)
               apply (cases a, simp_all)
               apply (metis InDomConc goal1(2) idNMT)
               apply (rule InDomConc, simp_all add: idNMT)+
               done
         next 
            case goal2 then show ?case  
               apply simp apply (rule impI)
               proof(cases "x \<in> dom (C (list2policy (insertDenies p)))")
                  case goal1 then show ?case
                     proof(induct a)
                        case DenyAll then show ?case by simp
                     next               
                        case (DenyAllFromTo src dest) then show ?case
                           apply simp by( rule InDomConc, simp add: idNMT)
                     next  
                       case (AllowPortFromTo src dest port) then show ?case
                           apply simp by(rule InDomConc, simp  add: idNMT)
                     next 
                       case (Conc _ _) then show ?case
                           apply simp by(rule InDomConc, simp add: idNMT)
                     qed
               next
                  case goal2 then show ?case
                     proof (induct a)
                       case DenyAll then show ?case by simp
                     next
                       case (DenyAllFromTo src dest) then show ?case
                   by(simp,metis domIff CConcStartA list2policyconc nlpaux Cdom2)
                     next
                       case (AllowPortFromTo src dest port) then show ?case
                   by(simp,metis domIff CConcStartA list2policyconc nlpaux Cdom2)
                     next
                       case (Conc _ _) then show ?case
                    apply simp
by (metis CConcStartA Cdom2 Conc(5) ConcAssoc domIff domdConcStart goal2(2)) 
                     qed
               qed
         qed
    qed
 qed
   

lemma DA_is_deny: 
  "x \<in> dom (C (DenyAllFromTo a b \<oplus> DenyAllFromTo b a \<oplus> DenyAllFromTo a b)) \<Longrightarrow>
C (DenyAllFromTo a b\<oplus>DenyAllFromTo b a \<oplus> DenyAllFromTo a b) x = Some (deny ())"
apply (case_tac "x \<in> dom (C (DenyAllFromTo a b))")
apply (simp_all add: PLemmas)
apply (simp_all split: if_splits)
done

lemma iDdomAux[rule_format]: 
  "p \<noteq> [] \<longrightarrow> x \<notin> dom (C (list2policy p)) \<longrightarrow>
   x \<in> dom (C (list2policy (insertDenies p))) \<longrightarrow>
   C (list2policy (insertDenies p)) x = Some (deny ())"
 proof (induct p)
  case Nil thus ?case by simp
  next
  case (Cons y ys) thus ?case
    proof (cases y) 
      case DenyAll then show ?thesis by simp next
      case (DenyAllFromTo a b) then show ?thesis using prems
        apply simp
        apply (rule impI)+
        proof (cases "ys = []")
          case goal1 then show ?case by (simp add: DA_is_deny) next
          case goal2 then show ?case
            apply simp
            apply (drule mp)
            apply (metis DenyAllFromTo InDomConc goal2(3) goal2(5))
            apply (cases "x \<in> dom (C (list2policy (insertDenies ys)))")
            apply simp_all
            apply (metis Cdom2 DenyAllFromTo goal2(5) idNMT list2policyconc)
            apply (subgoal_tac "C (list2policy (DenyAllFromTo a b \<oplus>
             DenyAllFromTo b a \<oplus> DenyAllFromTo a b#insertDenies ys)) x =
            C ((DenyAllFromTo a b \<oplus> DenyAllFromTo b a \<oplus> DenyAllFromTo a b)) x ")
            apply simp
            apply (rule DA_is_deny)
            apply (metis DenyAllFromTo domdConcStart goal2(4))
            apply (metis DenyAllFromTo l2p_aux2 list2policyconc nlpaux)
            done 
        qed
      next
      case (AllowPortFromTo a b c) then show ?thesis using prems
        proof (cases "ys = []")
          case goal1 then show ?case 
          apply simp
          apply (rule impI)+
       apply (subgoal_tac "x \<in> dom (C (DenyAllFromTo a b \<oplus> DenyAllFromTo b a))")
          apply (simp_all add: PLemmas)
          apply (simp split: if_splits) apply auto 
          done next
          case goal2 then show ?case
            apply simp
            apply (rule impI)+
            apply (drule mp)
            apply (metis AllowPortFromTo InDomConc goal2(4))
            apply (cases "x \<in> dom (C (list2policy (insertDenies ys)))")
            apply simp_all
            apply (metis AllowPortFromTo Cdom2 goal2(4) idNMT list2policyconc)
            apply (subgoal_tac "C (list2policy (DenyAllFromTo a b \<oplus>
                DenyAllFromTo b a \<oplus> AllowPortFromTo a b c#insertDenies ys)) x =
               C ((DenyAllFromTo a b \<oplus> DenyAllFromTo b a)) x ")
            apply simp
            defer 1 
            apply (metis AllowPortFromTo CConcStartA ConcAssoc goal2(4) idNMT
                         list2policyconc nlpaux)
            apply (simp add: PLemmas, simp split: if_splits) apply auto 
          done
         qed
      next
      case (Conc a b) then show ?thesis
 proof (cases "ys = []")
          case goal1 then show ?case 
            apply simp
            apply (rule impI)+
            apply (subgoal_tac "x \<in> dom (C (DenyAllFromTo (first_srcNet a)
         (first_destNet a) \<oplus> DenyAllFromTo (first_destNet a) (first_srcNet a)))")
            apply (simp_all add: PLemmas)
            apply (simp split: if_splits) apply auto 
            done next
          case goal2 then show ?case
            apply simp
            apply (rule impI)+
            apply (cases "x \<in> dom (C (list2policy (insertDenies ys)))")
           apply (metis Cdom2 Conc Cons InDomConc goal2(2) idNMT list2policyconc)
            apply (subgoal_tac "C (list2policy (DenyAllFromTo (first_srcNet a) 
            (first_destNet a) \<oplus> DenyAllFromTo (first_destNet a) (first_srcNet a)
            \<oplus> a\<oplus> b#insertDenies ys)) x =
            C ((DenyAllFromTo (first_srcNet a) (first_destNet a)  \<oplus>
            DenyAllFromTo (first_destNet a)  (first_srcNet a) \<oplus> a\<oplus> b)) x ")
            apply simp
            defer 1 
            apply (metis Conc l2p_aux2 list2policyconc nlpaux)
            apply (subgoal_tac "C ((DenyAllFromTo (first_srcNet a)
            (first_destNet a) \<oplus> DenyAllFromTo (first_destNet a)
            (first_srcNet a) \<oplus> a\<oplus> b)) x = C ((DenyAllFromTo (first_srcNet a)
     (first_destNet a)  \<oplus> DenyAllFromTo (first_destNet a)  (first_srcNet a))) x ")
            apply simp
            defer 1 
            apply (metis CConcStartA Conc ConcAssoc nlpaux)
            apply (simp add: PLemmas, simp split: if_splits) apply auto 
          done
        qed
    qed
qed         

lemma iD_isD[rule_format]: "p \<noteq> [] \<longrightarrow> x \<notin> dom (C (list2policy p))
          \<longrightarrow> C (DenyAll \<oplus> list2policy (insertDenies p)) x = C DenyAll x"
apply (case_tac "x \<in> dom (C (list2policy (insertDenies p)))")
apply (rule impI)+
apply (metis C.simps(1) deny_all_def iDdomAux Cdom2)
apply (rule impI)+
apply (subst nlpaux)
apply simp_all
done


lemma inDomConc:"\<lbrakk> x\<notin>dom (C a); x\<notin>dom (C (list2policy p))\<rbrakk> \<Longrightarrow>
                 x \<notin> dom (C (list2policy(a#p)))"
by (metis domdConcStart)

lemma domsdisj[rule_format]: "p \<noteq> [] \<longrightarrow> (\<forall> x s. s \<in> set p \<and> x \<in> dom (C A) \<longrightarrow> 
                             x \<notin> dom (C s)) \<longrightarrow> y \<in> dom (C A) \<longrightarrow>
                             y \<notin> dom (C (list2policy p))"
apply (induct p)
apply simp
apply (case_tac "p = []")
apply simp
apply (rule_tac x = y in spec)
apply (simp add: split_tupled_all)
apply (rule impI)+
apply (rule inDomConc)
apply (drule_tac x = y in spec, drule_tac x = a in spec)
apply auto
done

lemma isSepaux:
  "\<lbrakk>p \<noteq> []; noDenyAll (a#p); separated (a # p);
   x \<in> dom (C (DenyAllFromTo (first_srcNet a) (first_destNet a) \<oplus>
   DenyAllFromTo (first_destNet a) (first_srcNet a) \<oplus> a))\<rbrakk> \<Longrightarrow>
   x \<notin> dom (C (list2policy p))"
apply (rule_tac A = "(DenyAllFromTo (first_srcNet a) (first_destNet a) \<oplus>
             DenyAllFromTo (first_destNet a) (first_srcNet a) \<oplus> a)" in domsdisj)
apply simp_all
apply (rule notI)
apply (rule_tac p = xa and x ="(DenyAllFromTo (first_srcNet a) (first_destNet a) 
                \<oplus> DenyAllFromTo (first_destNet a) (first_srcNet a) \<oplus> a)" and
                y = s in disjSD_no_p_in_both)
apply simp_all
apply (simp add: disjSD_2_def)
apply (rule allI)+
apply (metis first_isIn tNDComm twoNetsDistinct_def)
apply (metis noDA)
done



lemma noneMTsep[rule_format]: "noneMT p \<longrightarrow> noneMT (separate p)"
apply (rule separate.induct) back
apply (simp_all add: C.simps map_add_le_mapE map_le_antisym)
done



lemma dom_id: 
  "\<lbrakk>noDenyAll (a#p); separated (a#p); p \<noteq> []; x \<notin> dom (C (list2policy p));
   x \<in> dom (C (a))\<rbrakk>
       \<Longrightarrow> x \<notin> dom (C (list2policy (insertDenies p)))"
apply (rule_tac a = a in isSepaux)
apply simp_all
apply (rule idNMT)
apply simp
apply (rule noDAID)
apply simp
apply (rule conjI)
apply (rule allI)
apply (rule impI)
apply (rule id_aux4)
apply simp_all
apply (rule sepNetsID)
apply simp_all
apply (metis noDA1eq)
apply (simp add: C.simps)
done

lemma C_eq_iD_aux2[rule_format]: 
 "noDenyAll1 p \<longrightarrow>
separated p\<longrightarrow>
p \<noteq> []\<longrightarrow>
x \<in> dom (C (list2policy p))\<longrightarrow>
C(list2policy (insertDenies p)) x = C(list2policy p) x"
proof (induct p)
case Nil thus ?case by simp 
next
case (Cons y ys)  thus ?case using prems
 proof (cases y)
 case DenyAll thus ?thesis using prems apply simp
   apply (case_tac "ys = []")
   apply simp_all
   apply (case_tac "x \<in> dom (C (list2policy ys))") 
   apply simp_all
apply (metis Cdom2 Combinators.simps(1) DenyAll FWCompilation.member.simps(3) 
bar3 domID idNMT in_set_conv_decomp insert_absorb insert_code list2policyconc
nMT_domMT noDA1C noDA1eq noDenyAll.simps(1) notMTpolicyimpnotMT notindom)
apply (metis DenyAll iD_isD idNMT list2policyconc nlpaux)
   done
 next
 case (DenyAllFromTo a b) thus ?thesis using prems apply simp
   apply (rule impI|rule allI|rule conjI|simp)+
   apply (case_tac "ys = []")
   apply simp_all
   apply (metis Cdom2 ConcAssoc DenyAllFromTo)
   apply (case_tac "x \<in> dom (C (list2policy ys))")
   apply simp_all
   apply (drule mp)
   apply (metis noDA1eq)
   apply (case_tac "x \<in> dom (C (list2policy (insertDenies ys)))")
   apply (metis Cdom2 DenyAllFromTo idNMT list2policyconc)
   apply (metis domID)
   apply (case_tac "x \<in> dom (C (list2policy (insertDenies ys)))")
   apply (subgoal_tac "C (list2policy (DenyAllFromTo a b \<oplus> DenyAllFromTo b a \<oplus>
                       DenyAllFromTo a b # insertDenies ys)) x = Some (deny ())")
   apply simp_all
   apply (subgoal_tac "C (list2policy (DenyAllFromTo a b # ys)) x =
                       C ((DenyAllFromTo a b)) x")
   apply (simp add: PLemmas, simp split: if_splits)
   apply (metis list2policyconc nlpaux)
   apply (metis Cdom2 DenyAllFromTo iD_isD iDdomAux idNMT list2policyconc mem_def)
apply (metis Cdom2 DenyAllFromTo domIff domdConcStart idNMT list2policyconc nlpaux)
   done
 next
 case (AllowPortFromTo a b c) thus ?thesis using prems apply simp
   apply (rule impI|rule allI|rule conjI|simp)+
   apply (case_tac "ys = []")
   apply simp_all
   apply (metis Cdom2 ConcAssoc AllowPortFromTo)
   apply (case_tac "x \<in> dom (C (list2policy ys))")
   apply simp_all
   apply (drule mp)
   apply (metis noDA1eq)
   apply (case_tac "x \<in> dom (C (list2policy (insertDenies ys)))")
   apply (metis Cdom2 AllowPortFromTo idNMT list2policyconc)
   apply (metis domID)
   apply (subgoal_tac "x \<in> dom (C (AllowPortFromTo a b c))")
   apply (case_tac "x \<notin> dom (C (list2policy (insertDenies ys)))")
   apply simp_all
   apply (metis AllowPortFromTo Cdom2 ConcAssoc l2p_aux2 list2policyconc nlpaux)
   apply (metis AllowPortFromTo Combinators.simps(6) FWCompilation.member.simps(4) 
                dom_id noDenyAll.simps(1) separated.simps(1))
   apply (metis AllowPortFromTo domdConcStart)
   done
 next
 case (Conc a b) thus ?thesis using prems apply simp
   apply (rule impI|rule allI|rule conjI|simp)+
   apply (case_tac "ys = []")
   apply simp_all
   apply (metis Cdom2 ConcAssoc Conc)
   apply (case_tac "x \<in> dom (C (list2policy ys))")
   apply simp_all
   apply (drule mp)
   apply (metis noDA1eq)
   apply (case_tac "x \<in> dom (C (a \<oplus> b))")
   apply (case_tac "x \<notin> dom (C (list2policy (insertDenies ys)))")
   apply simp_all
   apply (subst list2policyconc)
   apply (rule idNMT, simp)
   apply (metis domID)
   apply (metis Cdom2 Conc idNMT list2policyconc)
   apply (metis CConcEnd2 CConcStartA Cdom2 Conc aux0_4 domID domIff idNMT
     in_set_conv_decomp l2p_aux2 list2policyconc nMT_domMT
     notMTpolicyimpnotMT not_Cons_self notindom)
   apply (case_tac "x \<in> dom (C (a \<oplus> b))")
   apply (case_tac "x \<notin> dom (C (list2policy (insertDenies ys)))")
   apply simp_all
   apply (subst list2policyconc)
   apply (rule idNMT, simp)
   apply (metis Cdom2 Conc ConcAssoc list2policyconc nlpaux)
   apply (metis Conc FWCompilation.member.simps(1) dom_id 
                noDenyAll.simps(1) separated.simps(1))
   apply (metis Conc domdConcStart)
   done
 qed
qed

lemma C_eq_iD: "\<lbrakk>separated p; noDenyAll1 p; wellformed_policy1_strong p\<rbrakk>  \<Longrightarrow> 
 C (list2policy (insertDenies p)) = C (list2policy p)"
apply (rule ext)
apply (rule C_eq_iD_aux2)
apply simp_all 
apply (subgoal_tac "DenyAll \<in> set p")
apply (metis CConcStartA DAAux wp1n_tl)
apply (erule wp1_aux1aa)
done



lemmas CLemmas = noneMTsep nMTSort noneMTRS2 noneMTrd nMTRS3 separatedSep 
  noDAsort nDASC wp1_eq WP1rd wp1ID SC2 SCrd SCRS3 SCRiD SC1 SCp2l aND_sort 
  SC2 SCrd aND_RS2 ANDRS3 wellformed1_sorted wp1ID ANDiD  ANDrd SC1 aND_RS1 SC3 
  ANDSep OTNSEp OTNSC noDA1sep wp1_alternativesep wellformed1_alternative_sorted  
   distinct_RS2 

lemmas C_eqLemmas_id = C_eq_Lemmas_sep CLemmas OTNSEp NC2Sep NetsCollectedSep 
                        NetsCollectedSort separatedNC

lemma C_eq_Until_InsertDenies: "\<lbrakk>DenyAll \<in> set (policy2list p); all_in_list 
                          (policy2list p) l; allNetsDistinct (policy2list p)\<rbrakk> \<Longrightarrow> 
C (list2policy ((insertDenies (separate (sort (removeShadowRules2 (remdups
(removeShadowRules3 (insertDeny (removeShadowRules1 (policy2list p)))))) l))))) =
                                C p"
apply (subst C_eq_iD)
apply (simp_all add: C_eqLemmas_id)
apply (rule C_eq_until_separated)
apply simp_all
done


lemma C_eq_RD_aux[rule_format]: "C (p) x = C (removeDuplicates p) x" 
apply (induct p)
apply simp_all
apply (rule conjI, rule impI)
apply (metis Cdom2 domIff nlpaux not_in_member)
apply (metis C.simps(4) CConcStartaux Cdom2 domIff)
done

lemma C_eq_RAD_aux[rule_format]: 
  "p \<noteq> []  \<longrightarrow> C (list2policy p) x = C (list2policy (removeAllDuplicates p)) x"
apply (induct p)
apply simp_all
apply (case_tac "p = []")
apply simp_all
apply (metis C_eq_RD_aux)
apply (subst list2policyconc)
apply simp
apply (case_tac "x \<in> dom (C (list2policy p))")
apply (subst list2policyconc)
apply (rule rADnMT)
apply simp
apply (subst Cdom2)
apply simp
apply (drule sym)
apply (subst Cdom2)
apply (simp add: dom_def)
apply simp
apply (drule sym)
apply (subst nlpaux)
apply simp
apply (subst list2policyconc)
apply (rule rADnMT)
apply simp
apply (subst nlpaux)
apply (simp add: dom_def)
apply (rule C_eq_RD_aux)
done

lemma C_eq_RAD: 
  "p \<noteq> []  \<Longrightarrow> C (list2policy p) = C (list2policy (removeAllDuplicates p)) "
apply (rule ext)
apply (erule C_eq_RAD_aux)
done



lemma C_eq_compile: 
"\<lbrakk>DenyAll \<in> set (policy2list p); all_in_list (policy2list p) l; 
 allNetsDistinct (policy2list p)\<rbrakk> \<Longrightarrow> 
C (list2policy (removeAllDuplicates (insertDenies (separate (sort 
(removeShadowRules2 (remdups (removeShadowRules3 (insertDeny 
 (removeShadowRules1 (policy2list p)))))) l))))) = C p"
apply (subst C_eq_RAD[symmetric])
apply (rule idNMT)
apply (simp add: C_eqLemmas_id)
apply (rule C_eq_Until_InsertDenies) 
apply simp_all
done



lemma C_eq_normalize: 
"\<lbrakk>DenyAll \<in> set (policy2list p); 
 allNetsDistinct (policy2list p);
all_in_list (policy2list p) (Nets_List p)\<rbrakk> \<Longrightarrow> 
C (list2policy (normalize p)) = C p"
apply (simp add: normalize_def)
apply (rule C_eq_compile)
apply simp_all
done




lemma domSubset3: "dom (C (DenyAll \<oplus> x)) = dom (C (DenyAll))"
apply (simp add: PLemmas split_tupled_all split: option.splits)
done



lemma domSubset4: "dom (C (DenyAllFromTo x y \<oplus> DenyAllFromTo y x \<oplus> AllowPortFromTo x y dn)) = 
                  dom (C (DenyAllFromTo x y \<oplus> DenyAllFromTo y x))"
apply (simp add: PLemmas )
apply (simp split: option.splits decision.splits)
apply auto
done

lemma domSubset5: 
 "dom (C (DenyAllFromTo x y \<oplus> DenyAllFromTo y x \<oplus> AllowPortFromTo y x dn)) = 
                  dom (C (DenyAllFromTo x y \<oplus> DenyAllFromTo y x))"
apply (simp add: PLemmas)
apply (simp split: option.splits decision.splits)
apply auto
done



lemma domSubset1: "dom (C (DenyAllFromTo one two \<oplus> DenyAllFromTo two one \<oplus> AllowPortFromTo one two dn \<oplus> x)) = 
                  dom (C (DenyAllFromTo one two \<oplus> DenyAllFromTo two one \<oplus> x))"
apply (simp add: PLemmas)
apply (simp split: option.splits decision.splits)
apply (simp add: allow_all_def deny_all_def)
apply auto
done

lemma domSubset2: 
 "dom (C (DenyAllFromTo one two \<oplus> DenyAllFromTo two one \<oplus> AllowPortFromTo two one dn \<oplus> x)) = 
                  dom (C (DenyAllFromTo one two \<oplus> DenyAllFromTo two one \<oplus> x))"
apply (simp add: PLemmas)
apply (simp split: option.splits decision.splits)
apply (simp add: allow_all_def deny_all_def)
apply auto
done


lemma ConcAssoc2: "C (X \<oplus> Y \<oplus> ((A \<oplus> B) \<oplus> D)) = C (X \<oplus> Y \<oplus> A \<oplus> B \<oplus> D)"
apply (simp add: C.simps)
done


lemma RS3_NMT[rule_format]: "DenyAll \<in> set p \<longrightarrow>
    removeShadowRules3 p \<noteq> []"
apply (induct_tac p) 
apply (simp_all)
apply (simp_all add: PLemmas deny_all_def)
done

lemma norm_notMT: "DenyAll \<in> set (policy2list p) \<Longrightarrow> normalize p \<noteq> []"
apply (simp add: normalize_def)
apply (rule rADnMT)
apply (rule idNMT)
apply (rule sepnMT)
apply (rule sortnMT)
apply (rule RS2_NMT)
apply (rule remDupsNMT) 
apply (rule RS3_NMT)
apply (rule DAiniD)
done



lemma domDA: "dom (C (DenyAll \<oplus> A)) = dom (C (DenyAll))"
apply (rule domSubset3)
done


lemmas domain_reasoning = domDA ConcAssoc2 domSubset1 domSubset2 
 domSubset3 domSubset4  domSubset5 domSubsetNAT coerc_assoc





text {* The following lemmas help with the normalisation *}
lemma list2policyR_Start[rule_format]: "p \<in> dom (C a) \<longrightarrow>
                 C (list2policyR (a # list)) p = C a p"
apply (rule list2policyR.induct) back
apply (simp_all add: C.simps)
apply (simp_all add: C.simps dom_def map_add_def)
apply (simp split: option.splits)
apply (simp split: option.splits)
done


lemma list2policyR_End: "p \<notin> dom (C a) \<Longrightarrow>
        C (list2policyR (a # list)) p = (C a \<Oplus> list2policyP (Comb2PolList list C)) p"
apply (rule list2policyR.induct)
apply simp_all
apply (simp_all add: C.simps dom_def map_add_def)
apply (simp split: option.splits)
done


lemma l2polR_eq_el[rule_format]: "N \<noteq> [] \<longrightarrow>
 C( list2policyR N) p =  (list2policyP (Comb2PolList N C)) p"
apply (induct_tac N)
apply simp_all
apply (case_tac "p \<in> dom (C a)")
apply (simp add: domStart) 
apply (rule list2policyR_Start)
apply simp_all
apply (rule list2policyR.induct)
apply simp_all
apply (simp_all add: C.simps dom_def map_add_def)
apply (simp split: option.splits)
done


lemma l2polR_eq: "N \<noteq> [] \<Longrightarrow>
 C( list2policyR N) =  (list2policyP (Comb2PolList N C))"
by (rule ext, erule l2polR_eq_el)



lemma list2policys_eq_el[rule_format]: 
 "Filter \<noteq> []  \<longrightarrow>  C (list2policyR Filter) p =  C (list2policy (rev Filter)) p"
apply (induct_tac Filter)
apply simp_all
apply (case_tac "list = []")
apply simp_all
apply (case_tac "p \<in> dom (C a)")
apply simp_all
apply (rule list2policyR_Start)
apply simp_all
apply (subgoal_tac "C (list2policyR (a # list)) p = C (list2policyR list) p")
apply (subgoal_tac "C (list2policy (rev list @ [a])) p = C (list2policy (rev list)) p")
apply simp
apply (rule CConcStart2)
apply simp
apply simp
apply (thin_tac "?S")
apply (case_tac list,simp_all)
apply (simp_all add: C.simps dom_def map_add_def)
done

lemma list2policys_eq: 
 "Filter \<noteq> []  \<Longrightarrow>
  C (list2policyR Filter) =  C (list2policy (rev Filter))"
by (rule ext, erule list2policys_eq_el)


lemma list2policys_eq_sym: 
 "Filter \<noteq> []  \<Longrightarrow>
  C (list2policyR (rev Filter)) =  C (list2policy Filter)"
by (metis list2policys_eq rev_is_Nil_conv rev_rev_ident)


lemma p_eq[rule_format]: "p \<noteq> [] \<longrightarrow> 
 list2policyP (Comb2PolList (rev p) C) = C (list2policy p)"
by (metis l2polR_eq list2policys_eq_sym rev.simps(1) rev_rev_ident)


lemma p_eq2[rule_format]: "normalize x \<noteq> [] \<longrightarrow> 
  C (list2policy (normalize x)) = C x \<longrightarrow>
 list2policyP (Comb2PolList (rev (normalize x)) C) = C x"
apply (simp add: p_eq)
done

lemma list2listNMT[rule_format]: "x \<noteq> [] \<longrightarrow> Comb2PolList x sem \<noteq> []"
apply (case_tac x)
apply simp_all
done


lemma Norm_Distr2: 
 "r o_f ((P \<Otimes>\<^sub>2 (list2policyP Q)) o d) = 
  (list2policyP ((P \<Otimes>\<^sub>L Q) (op \<Otimes>\<^sub>2) r d))"
apply (rule ext, rule Norm_Distr)
done


lemma NATDistr: "\<lbrakk>N \<noteq> []; F = C (list2policyR N)\<rbrakk> \<Longrightarrow> 
  ((\<lambda> (x,y). x) o_f ((NAT \<Otimes>\<^sub>2 F) o (\<lambda> x. (x,x)))  = 
   (list2policyP (  ((NAT \<Otimes>\<^sub>L (Comb2PolList N C)) (op \<Otimes>\<^sub>2) 
    (\<lambda> (x,y). x) (\<lambda> x. (x,x))))))"
apply simp
apply (simp add: l2polR_eq) 
apply (rule Norm_Distr2)
done




text{* As an example, how this theorems can be used for a concrete
normalisation instantiation. *}

lemma normalizeNAT: "\<lbrakk>DenyAll \<in> set (policy2list Filter);
 allNetsDistinct (policy2list Filter); 
 all_in_list (policy2list Filter) (Nets_List Filter)\<rbrakk> \<Longrightarrow> 
 ((\<lambda> (x,y). x) o_f (((NAT \<Otimes>\<^sub>2 (C Filter)) o (\<lambda>x. (x,x)))))  = 
  list2policyP ((NAT \<Otimes>\<^sub>L (Comb2PolList (rev (normalize (Filter))) C)) (op \<Otimes>\<^sub>2) (\<lambda> (x,y). x) (\<lambda> x. (x,x)))"
apply (rule NATDistr)
apply simp_all
apply (metis FWCompilation.normalize_def norm_notMT)
by (metis C_eq_normalize list2policys_eq_sym norm_notMT)


end


