theory NAT
imports "../PacketFilter/PacketFilter"
begin



definition nat2pool :: "'\<alpha> set \<Rightarrow> '\<alpha> set \<Rightarrow> ('\<alpha>::adr,'\<beta>) packet \<mapsto> ('\<alpha>,'\<beta>) packet set" where 
 "nat2pool srcs transl = (\<lambda> p. if (src p \<in> srcs) then
         (Some (allow {(i,s,d,da). (i = id p \<and> s \<in> transl \<and> d = dest p \<and> da = content p)}))
                               else None)
                              " 


definition nat2pool_IntProtocolPort :: "int set \<Rightarrow> int set \<Rightarrow> 
 (IntegerPort_TCPUDP,'\<beta>) packet \<mapsto> (IntegerPort_TCPUDP,'\<beta>) packet set" where 
 "nat2pool_IntProtocolPort srcs transl =
      (\<lambda> p. if (fst (src p) \<in> srcs) then
 (Some (allow {(i,(s1,s2,s3),d,da). 
         (i = id p \<and> s1 \<in> transl \<and> s3 = (snd (snd (fst (snd p))))
         \<and> s2 =  src_port p \<and> d = dest p \<and> da = content p)}))
                              else None)" 



definition nat2pool_IntPort :: "address set \<Rightarrow> address set \<Rightarrow> 
 (IntegerPort,'\<beta>) packet \<mapsto> (IntegerPort,'\<beta>) packet set" where 
 "nat2pool_IntPort srcs transl =
      (\<lambda> p. if (fst (src p) \<in> srcs) then
 (Some (allow {(i,(s1,s2),d,c). 
         (i = id p \<and> s1 \<in> transl \<and> s2 =  src_port p \<and> 
           d = dest p \<and> c = content p)}))
       else None)" 





definition pat2pool_IntProtocol :: "int set \<Rightarrow> int set \<Rightarrow> (IntegerPort_TCPUDP,'\<beta>) packet \<mapsto> (IntegerPort_TCPUDP,'\<beta>) packet set" where 
 "pat2pool_IntProtocol srcs transl = (\<lambda> p. if (fst (src p) \<in> srcs) then
                          (Some (allow {(i,(s1,s2,s3),d,da). (i = id p \<and> s1 \<in> transl \<and> s3 = src_protocol p \<and> d = dest p \<and> da = content p)}))
                              else None)" 




definition pat2pool_int :: "int set \<Rightarrow> int set \<Rightarrow> (IntegerPort,'\<beta>) packet \<mapsto> 
                                            (IntegerPort,'\<beta>) packet set" where 
 "pat2pool_int srcs transl = (\<lambda> p. if (fst (src p)) \<in> srcs then
                          (Some (allow {(i,(s1,s2),d,da). 
        (i = id p \<and> s1 \<in> transl \<and> d = dest p \<and> da = content p)}))
                              else None)" 

definition NATID  where
 "NATID = (\<lambda>p. Some (allow {p}))"




lemma datasimp: "{(i, (s1, s2, s3), aba).
                 \<forall>a aa b ba. aba = ((a, aa, b), ba) \<longrightarrow> i = i1 \<and> s1 = i101 \<and> s3 = iudp \<and> a = i110 \<and> aa = X606X3 \<and> b = X607X4 \<and> ba = data} =
{(i, (s1, s2, s3), aba).
                 i = i1 \<and> s1 = i101 \<and> s3 = iudp \<and> (\<lambda> ((a,aa,b),ba). a = i110 \<and> aa = X606X3 \<and> b = X607X4 \<and> ba = data) aba}"
by auto

lemma datasimp2: "{(i, (s1, s2, s3), aba).
                \<forall>a aa b ba. aba = ((a, aa, b), ba) \<longrightarrow> i = i1 \<and> s1 = i132 \<and> s3 = iudp \<and> s2 = i1 \<and> a = i110 \<and> aa = i4 \<and> b = iudp \<and> ba = data}
= {(i, (s1, s2, s3), aba).
                 i = i1 \<and> s1 = i132 \<and> s3 = iudp \<and> s2 = i1 \<and> (\<lambda> ((a,aa,b),ba). a = i110 \<and> aa = i4 \<and> b = iudp \<and> ba = data) aba}"
by auto

lemma datasimp3: "{(i, (s1, s2, s3), aba).
             ALL a aa b ba. aba = ((a, aa, b), ba) --> i = i1 & i115 < s1 & s1 < i124 & s3 = iudp & s2 = ii1 & a = i110 & aa = i3 & b = itcp & ba = data}=
{(i, (s1, s2, s3), aba).
              i = i1 & i115 < s1 & s1 < i124 & s3 = iudp & s2 = ii1 & (\<lambda> ((a,aa,b),ba). a = i110 & aa = i3 & b = itcp & ba = data) aba}"
apply auto
done

lemma datasimp4: "{(i, (s1, s2, s3), aba).
                \<forall>a aa b ba. aba = ((a, aa, b), ba) \<longrightarrow> i = i1 \<and> s1 = i132 \<and> s3 = iudp \<and> s2 = ii1 \<and> a = i110 \<and> aa = i7 \<and> b = itcp \<and> ba = data}=
{(i, (s1, s2, s3), aba).
              i = i1 \<and> s1 = i132 \<and> s3 = iudp \<and> s2 = ii1 \<and> (\<lambda> ((a,aa,b),ba). a = i110 \<and> aa = i7 \<and> b = itcp \<and> ba = data) aba}"
apply auto
done

lemma datasimp5: " {(i, (s1, s2, s3), aba).
                 i = i1 \<and> s1 = i101 \<and> s3 = iudp \<and> (\<lambda> ((a,aa,b),ba). a = i110 \<and> aa = X606X3 \<and> b = X607X4 \<and> ba = data) aba}

 = {(i, (s1, s2, s3), (a,aa,b),ba).
                 i = i1 \<and> s1 = i101 \<and> s3 = iudp \<and>  a = i110 \<and> aa = X606X3 \<and> b = X607X4 \<and> ba = data}"
apply auto
done

lemma datasimp6: "{(i, (s1, s2, s3), aba).
                 i = i1 \<and> s1 = i132 \<and> s3 = iudp \<and> s2 = i1 \<and> (\<lambda> ((a,aa,b),ba). a = i110 \<and> aa = i4 \<and> b = iudp \<and> ba = data) aba}=
{(i, (s1, s2, s3), (a,aa,b),ba).
                 i = i1 \<and> s1 = i132 \<and> s3 = iudp \<and> s2 = i1 \<and> a = i110 \<and> aa = i4 \<and> b = iudp \<and> ba = data}"
apply auto
done

lemma datasimp7: "{(i, (s1, s2, s3), aba).
              i = i1 & i115 < s1 & s1 < i124 & s3 = iudp & s2 = ii1 & (\<lambda> ((a,aa,b),ba). a = i110 & aa = i3 & b = itcp & ba = data) aba} =
{(i, (s1, s2, s3), (a,aa,b),ba).
              i = i1 & i115 < s1 & s1 < i124 & s3 = iudp & s2 = ii1 & a = i110 & aa = i3 & b = itcp & ba = data}"
apply auto
done

lemma datasimp8: "{(i, (s1, s2, s3), aba).
              i = i1 \<and> s1 = i132 \<and> s3 = iudp \<and> s2 = ii1 \<and> (\<lambda> ((a,aa,b),ba). a = i110 \<and> aa = i7 \<and> b = itcp \<and> ba = data) aba}
= {(i, (s1, s2, s3), (a,aa,b),ba).
              i = i1 \<and> s1 = i132 \<and> s3 = iudp \<and> s2 = ii1 \<and>  a = i110 \<and> aa = i7 \<and> b = itcp \<and> ba = data}"
apply auto
done




lemmas datasimps = datasimp datasimp2 datasimp3 datasimp4
                   datasimp5 datasimp6 datasimp7 datasimp8


lemmas NATLemmas =  nat2pool_def prod_2_def
                    policy_range_comp_def
                    nat2pool_IntProtocolPort_def 
                    nat2pool_IntPort_def
                    pat2pool_int_def
                    pat2pool_IntProtocol_def
                    NATID_def






end